<?php
/*===============================================

	i_category.php v1.00
	By Woody-Rinn 2004

	携帯用カテゴリ表示プラグイン

使用方法
	1) このファイルを plugins ディレクトリに入れてください。
	2) スキンの該当場所に以下のような記述を追加します。
	<%=$plugin name="i_category"%>

===============================================*/
class i_category{
	var $category_pos;
	var $secret_category;

	function i_category(){
		//-------------------------------------
		// 初期設定
		//-------------------------------------
		// カテゴリの表示順
		// 指定出来るのはトップレベルカテゴリ名だけです。
		// 内部的に Home が 0, 指定の無いものは 9999 でソートしてますので、
		// 1～9998 で指定してください。

		$this->category_pos['info'] = 1;
		$this->category_pos['diary'] = 2;
		$this->category_pos['bbs'] = 9000;

		// 隠しカテゴリの指定
		// ここに列記されたカテゴリは表示されなくなります。
		// エントリの表示テスト等で使用します。
		//
		// 例えば、test カテゴリを隠しにしたい場合は、ここに設定すると同時に
		// 初期設定の $nodisp_at_toplv にも test を追加しておいて下さい。
		// test カテゴリの内容を表示するには
		// > rnote.php?u=test/
		// というように直接指定してください。

	//	$this->secret_category[] = 'test';
	}

	//==========================================================================
	// カテゴリ表示
	//==========================================================================
	function exec(){
		global $g_dirlist;			// ディレクトリ情報
		global $category_name;		// カテゴリ名変換テーブル

		// トップレベルのカテゴリを抽出
		foreach($g_dirlist as $d0 => $lst){
			$bSecret=false;
			if(is_array($this->secret_category)){
				foreach($this->secret_category as $s0){
					if(ereg("^$s0",$d0)) $bSecret=true;
				}
			}
			if(!$bSecret){
				$l[] = preg_replace('/\/.*$/','',$d0).'/';
			}
		}
		$l = array_unique($l);

		// カテゴリの表示順でソート
		foreach($l as $a) if($a){
			if($a=='/'){
				$l_2[] = '0000';
			}else{
				$d0 = preg_replace('/\/.*$/','',$a);
				if(isset($this->category_pos[$d0])){
					$l_2[] = sprintf("%04d",$this->category_pos[$d0]).$a;
				}else{
					$l_2[] = '9999'.$a;		// 指定無き物は下
				}
			}
		}
		sort($l_2);
		unset($l);
		foreach($l_2 as $a) $l[]=substr($a,4);

		// 出力
		$ret = "<form method=\"get\" action=\"".MakeLinkUrl()."\">\n";
		$ret .= "<select name=\"u\">\n";
		foreach($l as $a){
			if(!$a) $a='';
			$bSelect = false;
			$cn = preg_replace('/\/.*$/','',$a);
			if(($cn!='' && preg_match("/^$cn/",$_GET['u']))||($cn=='' && $_GET['u']=='')) $bSelect = true;
			if(isset($category_name[$cn])) $cn=$category_name[$cn];
			$ret .= "<option value=\"$a\"";
			if($bSelect) $ret .= " selected=\"selected\"";
			$ret .= ">$cn(".$g_dirlist[$a][DIRLIST_NUMITEM].")\n";
		}
		$ret .= "</select>\n";
		$ret .= "<input type=\"submit\" value=\"GO!\" />\n";
		$ret .= "</form>\n";
		return $ret;
	}
}
?>
