<?php
/*===============================================

	navitools.php v1.01
	By Woody-Rinn 2004

	ナビゲーションツール集プラグイン
	（Calendar,Archives,Categories）

使用方法
	1) このファイルを plugins ディレクトリに入れてください。
	2) スキンの該当場所に以下のような記述を追加します。
	<%=$plugin name="navitools" func="calendar" %>
	<%=$plugin name="navitools" func="archive" %>
	<%=$plugin name="navitools" func="category" %>

カテゴリ表示のオプション
	no-count	記事数を表示しません。
	no-home		「Home」を表示しません。
	両方同時に指定する場合は以下のように記述します。
	<%=$plugin name="navitools" func="category" opt="no-count,no-home" %>

アーカイブのオプション
	no-count	記事数を表示しません。

カレンダーのCSS指定
	rNote 0.9.3 までの本体内蔵版とは、若干 CSS の設定方法が異なります。

	table.calendar th		曜日表示部分、平日
	table.calendar th.su	曜日表示部分、日曜
	table.calendar th.sa	曜日表示部分、土曜
	table.calendar td		日付部分、平日
	table.calendar td.su	日付部分、日曜
	table.calendar td.sa	日付部分、土曜
	table.calendar tr.caption td	前後移動矢印部分
	table.calendar tr.caption th	キャプション（年と月）

===============================================*/
class navitools{
	var $week_name;
	var $month_name;
	var $calendar_title;
	var $category_pos;
	var $secret_category;

	function navitools(){
		//-------------------------------------
		// 初期設定
		//-------------------------------------
		//-------------------------------------
		// カレンダー

		// 洋式
		$this->week_name = array('Su','Mo','Tu','We','Th','Fr','Sa');
		$this->month_name = array(
			'January','February','March','April','May','June',
			'July','August','September','October','November','December');
		$this->calendar_title = '$month $year';

		// 和式
//		$this->week_name = array('日','月','火','水','木','金','土');
//		$this->month_name = array('1','2','3','4','5','6','7','8','9','10','11','12');
//		$this->calendar_title = '$year年$month月';

		//-------------------------------------
		// カテゴリ表示

		// カテゴリの表示順
		// 指定出来るのはトップレベルカテゴリ名だけです。
		// 内部的に Home が 0, 指定の無いものは 9999 でソートしてますので、
		// 1～9998 で指定してください。

		$this->category_pos['info'] = 1;
		$this->category_pos['diary'] = 2;
		$this->category_pos['bbs'] = 9000;

		// 隠しカテゴリの指定
		// ここに列記されたカテゴリは表示されなくなります。
		// エントリの表示テスト等で使用します。
		//
		// 例えば、test カテゴリを隠しにしたい場合は、ここに設定すると同時に
		// 初期設定の $nodisp_at_toplv にも test を追加しておいて下さい。
		// test カテゴリの内容を表示するには
		// > rnote.php?u=test/
		// というように直接指定してください。

	//	$this->secret_category[] = 'test';
	}

	//==========================================================================
	// カレンダー
	//==========================================================================
	function calendar($opt){
		global $nodisp_at_toplv;	// 表示しないカテゴリ一覧
		global $g_filelist;			// ファイル情報

		// まず最初に記事のある年と月のリストを作成
		if(is_array($g_filelist)){
			foreach($g_filelist as $fn => $lst){
				$bDisp=true;
				if(is_array($nodisp_at_toplv)){
					foreach($nodisp_at_toplv as $a){
						if(ereg("^$a",$fn)) $bDisp=false;
					}
				}
				if($bDisp){
					$ym_list_tmp[]=date('Y-m',$lst[FILELIST_DATE]);
				}
			}
			$ym_list_tmp = array_unique($ym_list_tmp);
			foreach($ym_list_tmp as $a) if(isset($a)) $ym_list[]=$a;
		}else{
			$ym_list[]=date('Y-m');
		}

		// どの月を表示するか？
		SplitPath($_GET['u'],$dir,$fname);
		if($fname){
			// 単一記事表示モード ... 現在表示されてる記事の月を表示
			$date = $g_filelist[str_replace(EXT_ACCESS,EXT_DOCUMENT,$_GET['u'])][FILELIST_DATE];
			$y = date('Y',$date);
			$m = date('m',$date);

			$ym_idx = 0;
			foreach($ym_list as $ym){
				if($ym=="$y-$m") break;
				$ym_idx++;
			}
			if($ym_idx>=sizeof($ym_list)) $ym_idx=-1;	// safety
		}elseif($_GET['d']){
			// 日付指定モード ... 指定された月を表示
			list($y,$m) = explode("-",$_GET['d']);
			// 年迄しか指定されていなかったら、その年の最終更新月を表示
			if($m==''){
				$ym_idx = 0;
				foreach($ym_list as $ym){
					if(substr($ym,0,4)==$y){
						$m=substr($ym,5,2); break;
					}
					$ym_idx++;
				}
				if($m==''){ $m='12'; $ym_idx=-1; }	// safety
			}else{
				$ym_idx = 0;
				foreach($ym_list as $ym){
					if($ym=="$y-$m") break;
					$ym_idx++;
				}
				if($ym_idx>=sizeof($ym_list)) $ym_idx=-1;	// safety
			}
		}else{
			// 通常状態 ... 最終更新月を表示
			$ym_idx = 0;
			$y = substr($ym_list[0],0,4);
			$m = substr($ym_list[0],5,2);
		}

		$t = mktime(0,0,0,(int)$m,1,(int)$y);	// 指定月の1日0時0分0秒の Unix Time
		$d0 = -(int)date('w',$t);	// 例えば1日が火曜なら-2から開始
		$max= (int)date('t',$t);	// その月の日数

		// HTML生成開始 ... まずはとにかくテーブル作っちゃおう
		$rep = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"calendar\">\n";
		// キャプションと前後移動
		$rep.= "<tr class=\"caption\"><td>";
		if($ym_idx!=-1 && $ym_idx<sizeof($ym_list)-1){
			$rep.="<a href=\"".MakeLinkUrl('',array('d'=>$ym_list[$ym_idx+1]))."\">«</a>";
		}
		$title = $this->calendar_title;
		$title = str_replace('$month',$this->month_name[(int)$m-1],$title);
		$title = str_replace('$year',$y,$title);
		$rep.= "</td><th colspan=\"5\">$title</th><td>";
		if($ym_idx>0){
			$rep.="<a href=\"".MakeLinkUrl('',array('d'=>$ym_list[$ym_idx-1]))."\">»</a>";
		}
		$rep.= "</td></tr>\n";
		// 曜日
		$rep.= '<tr>';
		for($x=0;$x<7;$x++){
			$rep.= "<th";
			if($x==0) $rep.=" class=\"su\""; elseif($x==6) $rep.=" class=\"sa\"";
			$rep.= ">".$this->week_name[$x]."</th>";
		}
		// 本体
		$rep.= "</tr>\n";
		while($d0<$max){
			$rep.= '<tr>';
			for($x=0;$x<7;$x++){
				$rep.= '<td';
				if($x==0) $rep.=" class=\"su\""; elseif($x==6) $rep.=" class=\"sa\"";
				$rep.= '>';
				if(($d0>=0)&&($d0<$max)){
					$rep.= ($d0+1);
				}
				$rep.= '</td>';
				$d0++;
			}
			$rep.= "</tr>\n";
		}
		$rep.= "</table>\n";

		// 記事ファイルを走査し、リンクを付けていく
		if(is_array($g_filelist)){
			foreach($g_filelist as $fn => $lst){
				$y0=date('Y',$lst[FILELIST_DATE]);
				$m0=date('m',$lst[FILELIST_DATE]);
				$d0=date('d',$lst[FILELIST_DATE]);
				if(((int)$y==(int)$y0)&&((int)$m==(int)$m0)){
					$bDisp=true;
					if(is_array($nodisp_at_toplv)){
						foreach($nodisp_at_toplv as $a){
							if(ereg("^$a",$fn)) $bDisp=false;
						}
					}
					if($bDisp) $rep = str_replace(">".(int)$d0."</td>",
						"><a href=\"".MakeLinkUrl('',array('d'=>"$y0-$m0-$d0"))."\" title=\"".
						$lst[FILELIST_TITLE]."\">".(int)$d0."</a></td>",$rep);
				}
			}
		}
		return $rep;
	}

	//==========================================================================
	// ulリスト生成サブルーチン
	//==========================================================================
	function MakeUL($l){
		$rep = '';
		$now_lv = 0;
		foreach($l as $a){
			if($a['lv']<=$now_lv) $rep.="</li>\n";
			while($a['lv']>$now_lv){$rep.="<ul>\n"; $now_lv++;}
			while($a['lv']<$now_lv){$rep.="</ul></li>\n";$now_lv--;}
			for($i=0;$i<$a['lv']-1;$i++) $rep.='  ';
			$rep.="<li>".$a['str'];
		}
		while($now_lv>0){
			$now_lv--;
			$rep.="</li>\n";
			for($i=0;$i<$now_lv-1;$i++) $rep.='  ';
			$rep.="</ul>";
		}
		return $rep;
	}

	//==========================================================================
	// アーカイブ（日付指定）
	//==========================================================================
	function archive($opt){
		global $nodisp_at_toplv;	// 表示しないカテゴリ一覧
		global $g_filelist;			// ファイル情報
		global $category_name;		// カテゴリ名変換テーブル

		if(! is_array($g_filelist)) return '';		// ファイルがない！

		$y0 = $m0 = $_m0 = '';
		$yNum = $mNum = 0;
		$yn = $mn = $n = 0;
		foreach($g_filelist as $fn => $lst){
			$bDisp=true;
			// トップレベル非表示カテゴリは除外
			if(is_array($nodisp_at_toplv)){
				foreach($nodisp_at_toplv as $a){
					if(ereg("^$a",$fn)) $bDisp=false;
				}
			}
			// リスト作成
			if($bDisp){
				$y=date('Y',$lst[FILELIST_DATE]);
				$m=date('m',$lst[FILELIST_DATE]);
				if($y0!=$y){
					if($yNum>0){
						if(isset($category_name[$y0])) $yy0=$category_name[$y0]; else $yy0=$y0;
						$l[$yn]['lv']=1;
						$l[$yn]['str']="<a href=\"".MakeLinkUrl('',array('d'=>$y0))."\">$yy0</a>";
						if(!ereg("no-count",$opt)) $l[$yn]['str'].=" ($yNum)";
					}
					$yn = $n; $n++; $y0=$y; $yNum=0;
				}
				if(ereg("^$y",$_GET['d'])){
					if($m0!=$m){
						if($mNum>0){
							if(isset($category_name[$m0])) $mm0=$category_name[$m0]; else $mm0=$m0;
							$l[$mn]['lv']=2;
							$l[$mn]['str']="<a href=\"".MakeLinkUrl('',array('d'=>$_m0))."\">$mm0</a>";
							if(!ereg("no-count",$opt)) $l[$mn]['str'].=" ($mNum)";
						}
						$mn = $n; $n++; $m0=$m; $mNum=0; $_m0="$y-$m";
					}
					$mNum++;
				}
				$yNum++; 
			}
		}
		if($yNum>0){
			if(isset($category_name[$y0])) $yy0=$category_name[$y0]; else $yy0=$y0;
			$l[$yn]['lv']=1; $l[$yn]['str']="<a href=\"".MakeLinkUrl('',array('d'=>$y0))."\">$yy0</a>";
			if(!ereg("no-count",$opt)) $l[$yn]['str'].=" ($yNum)";
		}
		if($mNum>0){
			if(isset($category_name[$m0])) $mm0=$category_name[$m0]; else $mm0=$m0;
			$l[$mn]['lv']=2; $l[$mn]['str']="<a href=\"".MakeLinkUrl('',array('d'=>$_m0))."\">$mm0</a>";
			if(!ereg("no-count",$opt)) $l[$mn]['str'].=" ($mNum)";
		}
		ksort($l);
		return $this->MakeUL($l);
	}

	//==========================================================================
	// カテゴリ表示
	//==========================================================================
	function category($opt){
		global $g_dirlist;			// ディレクトリ情報
		global $category_name;		// カテゴリ名変換テーブル

		// トップレベル、自分の親、兄弟階層、子供（一階層分）を抽出
		SplitPath($_GET['u'],$dir,$fn);
		$dd = preg_replace('/[^\/]+\/$/','',$dir);
		if(!$dd) $dd='';
		foreach($g_dirlist as $d0 => $lst){
			$bSecret=false;
			if(is_array($this->secret_category)){
				foreach($this->secret_category as $s0){
					if(ereg("^$s0",$d0)) $bSecret=true;
				}
			}
			if(!$bSecret){
				if(ereg("^[^/]+/$",$d0)||ereg("^$d0",$dir)){
					$l[] = $d0;
				}elseif(ereg("^$dir([^/]*)/",$d0,$tmp)){
					$l[] = $tmp[0];
				}elseif(ereg("^$dd([^/]*)/",$d0,$tmp)){
					$l[] = $tmp[0];
				}
			}
		}
		$l = array_unique($l);

		// カテゴリの表示順でソート
		if(is_array($this->category_pos)){
			foreach($l as $a){
				if($a==''){
					$l_2[] = '0000'.$a;		// Homeは一番上
				}else{
					$d0 = '';
					if(preg_match('/^([^\/]*)/',$a,$tmp)) $d0 = $tmp[1];
					if(isset($this->category_pos[$d0])){
						$l_2[] = sprintf("%04d",$this->category_pos[$d0]).$a;
					}else{
						$l_2[] = '9999'.$a;		// 指定無き物は一番下
					}
				}
			}
			sort($l_2);
			unset($l);
			foreach($l_2 as $a) $l[]=substr($a,4);
		}

		// MakeUL関数で出力
		$now_lv = 0;
		$n = 0;
		foreach($l as $a){
			if(!$a) $a='';
			$aa = explode("/",$a);
			$lv_org = $lv = sizeof($aa);
			if(ereg("no-home",$opt)) $lv-=1;
			if($lv>0){
				$ll[$n]['lv'] = $lv;
				$cn = $aa[max(0,$lv_org-2)];
				if(isset($category_name[$cn])) $cn=$category_name[$cn];
				if(!$cn) $cn='Home';

				$ll[$n]['str'] = "<a href=\"".MakeLinkUrl($a)."\">$cn</a>";
				if(!ereg("no-count",$opt)) $ll[$n]['str'] .= " (".$g_dirlist[$a][DIRLIST_NUMITEM].")";
				$n++;
			}
		}
		return $this->MakeUL($ll);
	}
}
?>
