<?php
/*---------------------------------------------------

	rNote

	by Woody-Rinn 2004
	http://rinn.e-site.jp/

---------------------------------------------------*/

//==================================================================================
// Defines and Global vars.
// 定数定義とグローバル
//==================================================================================

require("rnote_config.php");

//--------------------------
// internal defines

define(RNOTE_URL,'http://rinn.e-site.jp/rnote/');
define(RNOTE_VERSION,'0.9.7.5');

define(DEBUG_BUILDTIME,false);

define(TRACKBACK_POSTONLY,true);	// トラックバックはPOSTのみ受信

define(FNAME_FILECACHE,DIR_CACHE.'file.cache');
define(FNAME_DIRCACHE,DIR_CACHE.'dir.cache');
define(FNAME_RECENT_WB_LOG,DIR_CACHE.'recentwb.cache');
define(FNAME_CACHELIST,DIR_CACHE.'cachelist.cache');
define(FNAME_CONFIG,DIR_CACHE.'config.ini');

define(EXT_LOGFILE,'.log');
define(FNAME_REFERER,'_ref'.EXT_LOGFILE);

define(COOKIE_WRITEBACK,'rnote_wb_form');
define(COOKIE_LOGIN_ID_PASS,'rnote_admin_id_pass');
define(COOKIE_DOUBLEPOSTCHK,'rnote_double_post_chk');
define(COOKIE_TESTFLAG,'rnote_testflag');

define(REPLASE_CHAR,"\x07");
define(MB_DOUBLE_SPACE,'　');

define(ERR_NORMAL,0);
define(ERR_FATAL,1);
define(ERR_404,2);
define(ERR_WB,3);

$g_filelist;
define(FILELIST_DATE,0);
define(FILELIST_TITLE,1);
define(FILELIST_WBACCEPT,2);

$g_dirlist;
define(DIRLIST_NUMITEM,0);
define(DIRLIST_SKIN_BODY,1);
define(DIRLIST_SKIN_ITEM,2);

$g_bCellphone=false;
define(CELLPHONE_CHARSET,'Shift_JIS');
define(CELLPHONE_ENCODING,'SJIS-win');

//--------------------------
// messages
define(MSG_REBUILD,'キャッシュファイルの再構築とRSS生成を終了しました。');
define(MSG_REBUILD2,'サイトを表示');
define(MSG_LOGIN_COOKIE,'IDとPASSをクッキーに記憶させる');

define(ERR_MSG_TYPE_404,'Error: File not found.');
define(ERR_MSG_TYPE_WB,'Error: BBS及びツッコミの投稿エラー');

define(ERR_MSG_404,'指定のエントリは存在しません。');
define(ERR_MSG_404_REFIND,'似たエントリを発見しました。こちらに移動した可能性があります。');
define(ERR_MSG_DELETEENTRY,'このエントリは既に存在しません');
define(ERR_MSG_PHPVER,"PHPのバージョンが古いので動作出来ません。\nPHP 4.3 以上で動作します。");
define(ERR_MSG_MBSTRING,'マルチバイト文字列関数のサポートがありません。\nconfigureスクリプトで --enable-mbstring を指定してください。');
define(ERR_MSG_MBREGEX,'マルチバイト正規表現のサポートがありません。\nconfigureスクリプトで --enable-mbregex を指定してください。');
define(ERR_MSG_PASSWORD,"ID又はパスワードが不正です");
define(ERR_MSG_MACRO,"マクロ記述ミスのようです");

define(WB_ERR_ILLEGALSEND,"不正な投稿をしないで下さい。\nなお、ノートンセキュリティをお使いの方は、プライバシー制御を一時的にオフにしてください。");
define(WB_ERR_DONT_ACCESS,"このディレクトリへのファイル作成・消去等の操作は禁止されています");
define(WB_ERR_NOTEXT,"本文が書き込まれていません");
define(WB_ERR_LONGTEXT,"本文が長過ぎます");
define(WB_ERR_LONGQUERY,"要素が長過ぎます");
define(WB_ERR_DOUBLESEND,"二重投稿は禁止です");

define(BBS_ERR_NOID,"IDが指定されてません");
define(BBS_ERR_DELETE1,"指定記事の削除に失敗しました");
define(BBS_ERR_DELETE2,"ツッコミ等が追加されてる記事は削除出来ません");

//==================================================================================
// Common subroutines
// 汎用サブルーチン
//==================================================================================

if (!function_exists("file_get_contents")) {
	function file_get_contents($filename, $use_include_path = 0) {
		$data = ""; // just to be safe. Dunno, if this is really needed
		$file = @fopen($filename, "rb", $use_include_path);
		if ($file) {
			while (!feof($file)) $data .= fread($file, 1024);
			fclose($file);
		}
		return $data;
	}
}

function getmicrotime(){
	list($usec, $sec) = explode(" ",microtime());
	return ((float)$sec + (float)$usec);
}

function SplitPath($path,&$dir,&$fname){
	$dir = $fname = '';
	if(preg_match('/^[^\.]*[^\/]$/',$path)) $path .= '/';
	if(preg_match('/(^.*\/|^)(.*?)$/',$path,$tmp)){
		if($tmp[1]) $dir = $tmp[1];
		if($tmp[2]) $fname = $tmp[2];
	}
}

function strftime_jp($format,$timestamp,$locale){
	// '%z' ... time zone offset ( ex: '-09:00' )
	$offset = date('Z')/60;
	$szOffset='+';
	if($offset<0){ $szOffset='-'; $offset = -$offset; }
	$szOffset .= sprintf("%02d:%02d",$offset/60,$offset%60);
	$format = str_replace('%z',$szOffset,$format);

	// LC_TIME に ja が設定出来ないサーバー対策
	$bSet = setlocale(LC_TIME,$locale);
	if((!$bSet)&&(preg_match('/^ja/',$locale))){
		$youbi = array('日','月','火','水','木','金','土');
		$format = str_replace('%a',REPLASE_CHAR,$format);
		$ret = strftime($format,$timestamp);
		$ret = str_replace(REPLASE_CHAR,$youbi[date('w',$timestamp)],$ret);
	}else{
		$ret = strftime($format,$timestamp);
	}
	$ret = mb_convert_encoding($ret,SITE_CHARSET,"auto");
	return $ret;
}

function ext_change($fname,$new_ext){
	return preg_replace('/\.[^\/\.]*$/','',$fname) . $new_ext;
}

// Relative path -> Absolute path
function ChangeFullUrl(&$a){
	SplitPath($_SERVER['PHP_SELF'],$base,$tmp);
	$a = str_replace(REPLASE_CHAR,'',$a);
	while(preg_match('/<(?:a|img|link).+?(?:href|src|url)="(.*?)".*?>/s',$a,$tmp)){
		if(preg_match('/^(http|ftp|mailto|\/)/s',$tmp[1])){		// exclude
			$a = str_replace($tmp[0],str_replace('<',REPLASE_CHAR,$tmp[0]),$a);
		}else{
			$repstr = preg_replace("/(href|src|url)=\"/s","\\1=\"".$base,$tmp[0]);
			$a = str_replace($tmp[0],str_replace('<',REPLASE_CHAR,$repstr),$a);
		}
	}
	$a = str_replace(REPLASE_CHAR,'<',$a);
	return;
}

// 携帯用にShift_JISに変換
function mb_convert_cellphone($str){
	$str = str_replace('«','&lt;',$str);
	$str = str_replace('»','&gt;',$str);
	$str = mb_convert_encoding($str,CELLPHONE_ENCODING,SITE_CHARSET);
	$str = str_replace("\0",'?',$str);
	return $str;
}

function error_output($output){
	global $g_bCellphone;
	$head = CONTENT_TYPE_HTML;
	if($g_bCellphone){
		$head = ereg_replace(SITE_CHARSET,CELLPHONE_CHARSET,$head);
		$output = mb_convert_cellphone($output);
	}
	header($head);
	print $output;
	exit;
}
function error_noskin($mes,$typemes='rNote Error'){
	error_output("<html><body>\n<h1>$typemes</h1>\n$mes\n</body></html>");
}
function error($mes,$code=ERR_NORMAL,$mes2=''){
	global $g_bCellphone;

	switch($code){
	case ERR_404: $typemsg = ERR_MSG_TYPE_404; break;
	case ERR_WB:  $typemsg = ERR_MSG_TYPE_WB; break;
	default:      $typemsg = 'rNote Error';
	}

	if($code==ERR_404) $mes.=' : '.ERR_MSG_404;
	$mes = "<p>$mes</p>\n";
	if($mes2) $mes .= "<p>$mes2</p>\n";

	$back_url = getenv("HTTP_REFERER");
	if($back_url){
		$mes .= "<form action=\"$back_url\" method=\"post\">\n";
		$mes .= "<input type=\"submit\" value=\"Back\" /></form>\n";
	}

	$skin=FNAME_SKIN_ERROR;
	if($g_bCellphone) $skin = ext_change($skin,'_i'.FNAME_SKIN_EXT);
	if(!file_exists($skin)) error_noskin($mes,$typemsg);

	$a = _file_get_contents($skin);
	$a = preg_replace("/<!---.*?--->\n?/s",'',$a);

	if(! preg_match('/<%=\$error_message.*?%>/',$a,$tagstr)) error_noskin($mes,$typemsg);
	if(! preg_match('/<%=\$error_type.*?%>/',$a,$tagstr)) $mes = "<h2>$typemsg</h2>\n$mes";
	$a = preg_replace('/<%=\$error_message.*?%>/',$mes,$a);
	$a = preg_replace('/<%=\$error_type.*?%>/',$typemsg,$a);
	$a = preg_replace('/<%=\$site_title.*?%>/',SITE_TITLE,$a);
	$a = preg_replace('/<%=\$site_url.*?%>/',SITE_URL,$a);
	$a = preg_replace('/<%=\$site_charset.*?%>/',SITE_CHARSET,$a);
	$a = preg_replace('/<%=\$site_lang.*?%>/',SITE_LANG,$a);
	$a = preg_replace('/<%=\$site_author.*?%>/',SITE_AUTHOR,$a);
	$a = preg_replace('/<%=\$rnote_version.*?%>/',RNOTE_VERSION,$a);
	$a = preg_replace('/<%=\$rnote_url.*?%>/',RNOTE_URL,$a);

	if(USE_MOD_REWRITE) ChangeFullUrl($a);
	error_output($a);
}

function _file_get_contents($fname){
	if(!file_exists($fname)) error_noskin("$fname : File not found");
	$a = @file_get_contents($fname);
	if($a===false) error_noskin("$fname : File read error");
	if((ord($a{0})==0xef)&&(ord($a{1})==0xbb)&&(ord($a{2})==0xbf)) $a = substr($a,3);	// utf-8 bom delete
	$a = str_replace("\r","\n",str_replace("\r\n","\r",$a));
	return $a;
}
function _file($fname){
	if(!file_exists($fname)) error_noskin("$fname : File not found");
	$a = @file($fname);
	if($a===false) error_noskin("$fname : File read error");
	return $a;
}

function _fopen_wb($fname){
	$fp = @fopen($fname, "wb");
	if(! $fp) error("$fname : File write error");
	set_file_buffer($fp, 0);
	flock($fp, LOCK_EX);
	rewind($fp);
	return $fp;
}

function get_XMLTag($tag,&$str){
	if(preg_match("/<$tag.*?>[[:space:]]*(.*)[[:space:]]*<\/$tag>/s",$str,$buf)) {
		return $buf[1];
	}
	return '';
}

function bool_opt_chk($opt,$def){
	// $def : $optがnullだった時のディフォルト
	if($opt=='') return $def;
	if(($opt=='on')||($opt=='true')||($opt=='yes')||($opt==1)) return true;
	return false;
}

function MakeLinkUrl($fname='',$query='',$bFullPath=false){
	$fname = str_replace(EXT_DOCUMENT,EXT_ACCESS,$fname);
	if(USE_MOD_REWRITE){
		SplitPath($_SERVER['PHP_SELF'],$base,$tmp);
		$base .= $fname;
		unset($fname);
	}else{
		$base = $_SERVER['PHP_SELF'];
	}
	unset($q);
	if($fname)      $q[]='u='.$fname;
	if($query['d']) $q[]='d='.$query['d'];		// date
	if($query['p']) $q[]='p='.$query['p'];		// page
	if($query['s']) $q[]='s='.$query['s'];		// skin
	if($query['c']) $q[]='c='.$query['c'];		// content-type
	if($query['m']) $q[]='m='.$query['m'];		// mode

	for($i=0;$i<sizeof($q);$i++){
		if($i==0) $base .= '?'.$q[$i]; else $base .= '&'.$q[$i];
	}
	if(bool_opt_chk($bFullPath,false)){
		$base = 'http://'.$_SERVER["HTTP_HOST"].$base;
	}
	return $base;
}

function SwapData(&$d1,&$d2){
	$tmp = $d1; $d1 = $d2; $d2 = $tmp;
}

// W3C-DTF->Unix Time
function w3cdtf_to_time($datetime){
	list($year,$month,$day,$hour,$minute,$second) = explode(' ',preg_replace('/[^0-9]+/',' ',$datetime));
	if(!$year) $year=1970;
	if(!$month) $month=1;
	if(!$day) $day=1;
	if(($month>12)||($day>31)||($hour>24)||($minute>60)||($second>60)) return false;
	$offset_hour = $offset_minute = 0;
	if(preg_match('/(\+|-)(\d+):(\d+)$/', $datetime, $val)){
		$offset_hour   = $val[1].$val[2];
		$offset_minute = $val[1].$val[3];
	}
	return mktime($hour - $offset_hour, $minute - $offset_minute, $second, $month, $day, $year);
}

//RFC 822(1123)、RFC 850(1036)、ANSI C's asctime() -> unixtime
function parse_rfctime($string_date){
	if(!$string_date) return 0;
	$define_month = array(
		1=>"Jan",2=>"Feb",3=>"Mar",4=>"Apr",5=>"May",6=>"Jun",
		7=>"Jul",8=>"Aug",9=>"Sep",10=>"Oct",11=>"Nov",12=>"Dec"
	);
	if( preg_match( "/^(Mon|Tue|Wed|Thu|Fri|Sat|Sun), ([0-3][0-9]) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ([0-9]{4}) ([0-2][0-9]):([0-5][0-9]):([0-5][0-9]) GMT$/", $string_date, $tmp ) ) {
		$hour = $tmp[5];
		$minute = $tmp[6];
		$second = $tmp[7];
		$month = array_search( $tmp[3], $define_month );
		$day = $tmp[2];
		$year = $tmp[4];
	} elseif( preg_match( "/^(Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday), ([0-3][0-9])-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-([0-9]{2}) ([0-2][0-9]):([0-5][0-9]):([0-5][0-9]) GMT$/", $string_date, $tmp ) ) {
		$hour = $tmp[5];
		$minute = $tmp[6];
		$second = $tmp[7];
		$month = array_search( $tmp[3], $define_month );
		$day = $tmp[2];
		$year = 1900 + $tmp[4];
	} elseif( preg_match( "/^(Mon|Tue|Wed|Thu|Fri|Sat|Sun) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ([0-3 ][0-9]) ([0-2][0-9]):([0-5][0-9]):([0-5][0-9]) ([0-9]{4})$/", $string_date, $tmp ) ) {
		$hour = $tmp[4];
		$minute = $tmp[5];
		$second = $tmp[6];
		$month = array_search( $tmp[2], $define_month );
		$day = str_replace( " ", 0, $tmp[3] );
		$year = $tmp[7];
	} else {
		return 0;
	}
	return gmmktime( $hour, $minute, $second, $month, $day, $year );
}

//==================================================================================
// WriteBack,TrackBack,RefererSave,BBS
// ツッコミ、トラックバック、リンク元記録、BBS関係
//==================================================================================

function form_treatment($value,$bConvertEnc,$bStripCRLF,$bStripTags){
	global $g_bCellphone;
	if($bConvertEnc || $g_bCellphone){
		$value = mb_convert_encoding($value,SITE_CHARSET,"auto");
		$value = str_replace("\0",'?',$value);
	}
	if (get_magic_quotes_gpc()) $value = stripslashes($value);
	if($bStripTags) $value = strip_tags($value);
	$value = htmlspecialchars($value);
	if(!$bStripCRLF){
		$value = str_replace("\r","\n",str_replace("\r\n","\r",$value));
		$value = preg_replace("/\n((".MB_DOUBLE_SPACE."| |\t)*\n){2,}/s","\n\n",$value);
		$value = preg_replace("/^\n+/s",'',$value);
		$value = preg_replace("/\n+$/s",'',$value);
		$value = nl2br($value);
	}
	$value = preg_replace("/[\t\n\r\f]/","", $value);
	return $value;
}

function SaveWBLog($type,$fname,$value){
	global $g_config;
	$time = time();
	$data="$type\t$fname\t$value\t$time\n";
	unset($logfile);
	if(file_exists(FNAME_RECENT_WB_LOG)){
		$logfile = _file(FNAME_RECENT_WB_LOG);
		array_unshift($logfile,$data);
	}else{
		$logfile[] = $data;
	}
	$fp = _fopen_wb(FNAME_RECENT_WB_LOG);
	$num = 0;
	foreach($logfile as $a){
		fwrite($fp,$a);
		$num++; if($num>$g_config['resent_wb_log_max']) break;
	}
	fclose($fp);
}

// ２重投稿禁止のための強制ジャンプ。
function RefreshJump($path){
	global $g_config,$g_bCellphone;
	if($g_bCellphone) return;

	// Operaは Location: にバグがあってリロード中に止まる
	if(ereg('Opera',$_SERVER["HTTP_USER_AGENT"])) return;
	// Mozillaはキャッシュコントロールを行うと、ある条件下で、飛んでも
	// 強制的にキャッシュ使用になってしまう（GET要求すら来ない）時がある
	if($g_config['return_if_modified'] && ereg('Gecko/',$_SERVER["HTTP_USER_AGENT"])) return;
	header("Location: $path");
	exit;
}

// ２重投稿チェック。クッキー無効になってると無力だけど…
function DoublePostChk($str){
	$data = md5($str);
	if($_COOKIE[COOKIE_DOUBLEPOSTCHK]==$data) error(WB_ERR_DOUBLESEND,ERR_WB);
	setcookie(COOKIE_DOUBLEPOSTCHK, $data);		// セッションオンリーで投稿内容を記録しておく
}

define(WB_FLAG_NOACCEPT,0);
define(WB_FLAG_ACCEPT,1);
define(WB_FLAG_TIMEOVER,2);

function IsWBAccept($fname){
	global $wb_acceptdays,$g_filelist;
	$iAccept=WB_FLAG_ACCEPT;
	$fname = ext_change($fname,EXT_DOCUMENT);
	$day = $g_filelist[$fname][FILELIST_WBACCEPT];
	if((string)$day==''){
		$day=$wb_acceptdays[''];
		foreach($wb_acceptdays as $_dn => $_day) if(ereg("^$_dn",$fname)) $day=$_day;
	}
	if($day==0){
		$iAccept=WB_FLAG_NOACCEPT;
	}elseif($day>0){
		if( $g_filelist[$fname][FILELIST_DATE] + $day*24*60*60 < time() ) $iAccept=WB_FLAG_TIMEOVER;
	}
	return $iAccept;
}

define(LINK_REP_STR,"/(https?|ftp|news)(:\/\/[[:alnum:]\+\$\;\?\.%,!#~*\/:@&=_-]+)/");
function autolink($url){
	$url = preg_replace(LINK_REP_STR,"<a href=\"\\1\\2\" target=\"_blank\">\\1\\2</a>",$url);
	return $url;
}

//=====================================
// TrackBack

function TrackbackError($msg){
	header(CONTENT_TYPE_XML);
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<response>\n<error>1</error>\n";
	print "<message>$msg</message>\n</response>\n";
	exit;
}

function TrackBackSave(){
	if($_POST['url']){
		$url = $_POST['url'];
		$blog_name = $_POST['blog_name'];
		$excerpt = $_POST['excerpt'];
		$title = $_POST['title'];
	}else{
		$url = $_GET['url'];
		$blog_name = $_GET['blog_name'];
		$excerpt = $_GET['excerpt'];
		$title = $_GET['title'];
	}
	$u = $_GET['u'];

	$logfile = DIR_DATA.ext_change($u,EXT_DOCUMENT);
	if(! file_exists($logfile)) TrackbackError('Trackback URL is invalid.');
	if(IsWBAccept($u)!=WB_FLAG_ACCEPT) TrackbackError('This entry is not accept trackback.');

	$blog_name	= form_treatment($blog_name,true,true,true);
	$url		= form_treatment($url,true,true,true);
	$title		= form_treatment($title,true,true,true);
	$excerpt	= form_treatment($excerpt,true,true,true);

	if(!$title) $title=$url;
	$times = time();
	$new_msg = "$title\t$url\t$excerpt\t$times\t$blog_name\ttb\n";

	$logfile = DIR_DATA.ext_change($u,EXT_LOGFILE);

	if(file_exists($logfile)){
		$data = _file($logfile);
		foreach($data as $a){
			list ($_name,$_url,$_com,$_times,$_title,$_mode) = explode("\t",str_replace("\n","",$a));
			if(($_mode=='tb')&&($_url==$url)){
				TrackbackError('This trackback entry already exists.');
			}
		}
	}

	$fp = @fopen($logfile, "a");
	flock($fp, 2);
	fputs($fp,$new_msg);
	fclose($fp);
	@chmod($logfile,0666);

	header(CONTENT_TYPE_XML);
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<response>\n<error>0</error>\n</response>\n";

	SaveWBLog('tb',ext_change($u,EXT_DOCUMENT),$url);
	exit;
}

//=====================================
// WriteBack

function WriteBackSave(){
	global $g_bCellphone;

	$com = $_POST['Text'];
	$name = $_POST['AuthorName'];
	$wburl = $_POST['AuthorUrl'];
	$file = $_GET['u'];

	DoublePostChk($name.$com);

	$logfile = DIR_DATA.ext_change($file,EXT_DOCUMENT);
	if(! file_exists($logfile)) error(WB_ERR_ILLEGALSEND,ERR_WB);

	if(!$g_bCellphone){
		if(!preg_match("/".$_SERVER["HTTP_HOST"]."/i",getenv("HTTP_REFERER"))) error(WB_ERR_ILLEGALSEND,ERR_WB);
	}
	if(!$name||preg_match("/^( |".MB_DOUBLE_SPACE.")*$/",$name)) $name = BBS_DEFAULT_NAME;
	if(!$com||preg_match("/^( |".MB_DOUBLE_SPACE."|\t|\r|\n)*$/",$com)) error(WB_ERR_NOTEXT,ERR_WB);
	if(strlen($name)  > WRITEBACK_MAXQUERY) error(WB_ERR_LONGQUERY,ERR_WB);
	if(strlen($wburl) > WRITEBACK_MAXQUERY) error(WB_ERR_LONGQUERY,ERR_WB);
	if(strlen($com)   > WRITEBACK_MAXTEXT ) error(WB_ERR_LONGTEXT,ERR_WB);

	$name = form_treatment($name ,FORM_CONVENC_AUTO,true,true);
	$wburl= form_treatment($wburl,FORM_CONVENC_AUTO,true,true);
	$com  = form_treatment($com  ,FORM_CONVENC_AUTO,false,false);

	// write log
	$logfile = DIR_DATA.ext_change($file,EXT_LOGFILE);
	$times = time();
	$new_msg = "$name\t$wburl\t$com\t$times\n";
	if(file_exists($logfile)){
		$old_log = _file($logfile);
		$line = sizeof($old_log);
		list($tname,$turl,$tcom,$ttimes) = explode("\t", str_replace("\n","",$old_log[$line-1]));
		if(($name == $tname)&&($com == $tcom)) error(WB_ERR_DOUBLESEND,ERR_WB);
	}
	$fp = @fopen($logfile, "a");
	flock($fp, 2);
	fputs($fp,$new_msg);
	fclose($fp);
	@chmod($logfile,0666);

	// save cookie
	list($ck_name,$ck_url,$ck_pass) = explode("\t", $_COOKIE[COOKIE_WRITEBACK]);
	$_COOKIE[COOKIE_WRITEBACK] = implode("\t", array($name,$wburl,$ck_pass));
	SplitPath($_SERVER['PHP_SELF'],$p0,$f0);
	setcookie(COOKIE_WRITEBACK, $_COOKIE[COOKIE_WRITEBACK], time()+2*7*24*3600, $p0);  // limit two weeks

	// Save writeback log
	SaveWBLog('wb',ext_change($file,EXT_DOCUMENT),$name);

	// refresh
	RefreshJump(MakeLinkUrl($file,'',true)."#wb");
}

//===============================================
// BBS

function bbs_write(){
	global $g_bCellphone,$dir_access_enable;
	unset($post);
	foreach($_POST as $key0 => $value) if(ereg("^tag_",$key0)) $post[substr($key0,4)] = $value;

	if(!$g_bCellphone){
		if(!preg_match("/".$_SERVER["HTTP_HOST"]."/i",getenv("HTTP_REFERER"))) error(WB_ERR_ILLEGALSEND,ERR_WB);
	}
	DoublePostChk($post[TAG_TITLE].$post[TAG_BBS_NAME].$post[TAG_TEXT]);

	SplitPath($_GET['u'],$dir,$fname);
	if(array_search($dir,$dir_access_enable)===false) error(WB_ERR_DONT_ACCESS,ERR_WB);
	$now = time();
	while(true){
		$fname = $dir.date("YmdHis",$now).'.xml';
		if(!file_exists(DIR_DATA.$fname)) break;
		$now++;
	}

	// Create entry file
	$a = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><rNote>\n";
	$a .= "<".TAG_DATE.">".date("Y-m-d\TH:i:s",$now)."</".TAG_DATE.">\n";
	if(!$post[TAG_TITLE]) $post[TAG_TITLE] = BBS_DEFAULT_TITLE;
	if(!$post[TAG_BBS_NAME]) $post[TAG_BBS_NAME] = BBS_DEFAULT_NAME;
	foreach($post as $key => $value){
		if($key==TAG_TEXT){
			if(!$value||preg_match("/^( |".MB_DOUBLE_SPACE."|\t|\r|\n)*$/",$value)) error(WB_ERR_NOTEXT,ERR_WB);
			if(strlen($value) > BBS_MAXTEXT) error(WB_ERR_LONGTEXT,ERR_WB);
			$value = form_treatment($value,FORM_CONVENC_AUTO,false,false);
			$value = preg_replace("/<br(| \/)>/","<br />\n",$value);
		}else{
			if(strlen($value) > WRITEBACK_MAXQUERY) error(WB_ERR_LONGQUERY,ERR_WB);
			if($key==TAG_BBS_URL) $value = str_replace("@",MEASURES_FOR_SPAM,$value);
			if($key==TAG_BBS_PASS) $value=md5($value);
			$value = form_treatment($value,FORM_CONVENC_AUTO,true,true);
			if($key==TAG_TITLE) $value_title = $value;
			if($key==TAG_BBS_NAME) $value_name = $value;
		}
		if($value) $a .= "<$key>$value</$key>\n";
	}
	$a .= '</rNote>';

	// file save
	$fp = _fopen_wb(DIR_DATA.$fname);
	fwrite($fp,$a);
	fclose($fp);
	@chmod(DIR_DATA.$fname,0666);

	// save cookie
	$_COOKIE[COOKIE_WRITEBACK] = 
		implode("\t", array($value_name,$post[TAG_BBS_URL],$post[TAG_BBS_PASS]) );
	SplitPath($_SERVER['PHP_SELF'],$p0,$f0);
	setcookie(COOKIE_WRITEBACK, $_COOKIE[COOKIE_WRITEBACK], time()+2*7*24*3600, $p0);  // limit two weeks

	// refresh cache
	FileCache_AddEntry($fname,$now,$value_title,'');

	// Save Last-Modified time
	SaveWBLog('bw',$fname,$value_name);

	// refresh
	RefreshJump(MakeLinkUrl($_GET['u'],'',true));
}

function bbs_delete(){
	global $dir_access_enable;
	if(!preg_match("/".$_SERVER["HTTP_HOST"]."/i",getenv("HTTP_REFERER"))) error(WB_ERR_ILLEGALSEND,ERR_WB);
	$delete_id = $_POST['bbs_delete_id'];
	if(!$delete_id) error(BBS_ERR_NOID,ERR_WB);
	foreach($delete_id as $id){
		$fname = ext_change($id,EXT_DOCUMENT);
		SplitPath($fname,$dir,$fn);
		if(array_search($dir,$dir_access_enable)===false) error(WB_ERR_DONT_ACCESS,ERR_WB);
		if(!file_exists(DIR_DATA.$fname)) error(BBS_ERR_DELETE1,ERR_WB);
		if(file_exists(ext_change(DIR_DATA.$fname,EXT_LOGFILE))) error(BBS_ERR_DELETE2,ERR_WB);

		$tmp = _file_get_contents(DIR_DATA.$fname);
		$pass= get_XMLTag(TAG_BBS_PASS,$tmp);
		if((md5($_POST['tag_'.TAG_BBS_PASS])!=$pass)&&($_POST['tag_'.TAG_BBS_PASS]!=ADMIN_PASSWORD))
			error(ERR_MSG_PASSWORD,ERR_WB);
		if(! unlink(DIR_DATA.$fname)) error(BBS_ERR_DELETE1,ERR_WB);

		// refresh cache
		FileCache_DeleteEntry($fname);

		// Save Last-Modified time
		if($_POST['tag_'.TAG_BBS_PASS]==ADMIN_PASSWORD) $comment='Owner'; else $comment='User';
		SaveWBLog('bd',$fname,$comment);
	}
	// refresh
	RefreshJump(MakeLinkUrl($_GET['u'],'',true));
}

//===============================================
// Save Referer

function RefererCheck(){
	global $no_referer_site;
	$HTTP_REFERER = $_SERVER['HTTP_REFERER'];
	$u = $_GET['u'];

	SplitPath($u,$dir,$fname);
	SplitPath($_SERVER['PHP_SELF'],$php_dir,$phpname);
	$php_dir = ereg_replace('/$','',$php_dir);

	if( $fname=='' || $HTTP_REFERER=='' ) return;
	if(!ereg("^https?://.{6,}",$HTTP_REFERER)) return;
	if(ereg($_SERVER['HTTP_HOST'].$php_dir,$HTTP_REFERER)) return;
	foreach($no_referer_site as $n) if(ereg($n,$HTTP_REFERER)) return;
	if(IsWBAccept($u)!=WB_FLAG_ACCEPT) return;

	$logfile = DIR_DATA.ext_change($u,FNAME_REFERER);
	$bNew=true;
	if(file_exists($logfile)){
		$data = _file($logfile);
		foreach($data as $a){
			list($site,$count) = explode("\t",str_replace("\n","",$a));
			if(REFERER_MERGE){
				if(ereg("^$site",$HTTP_REFERER)){
					$bNew=false; $data2[$site] = $count+1;
				}
				elseif(ereg("^".$HTTP_REFERER,$site)){
					$bNew=false; $data2[$HTTP_REFERER] = $count+1;
				}else{
					$data2[$site] = $count;
				}
			}else{
				$data2[$site] = $count;
				if($site==$HTTP_REFERER){
					$bNew=false; $data2[$site]++;
				}
			}
		}
	}
	if($bNew){
		$data2[$HTTP_REFERER] = 1;
		SaveWBLog('rf',ext_change($u,EXT_DOCUMENT),$HTTP_REFERER);
	}
	arsort($data2);

	$fp = _fopen_wb($logfile);
	foreach ($data2 as $site => $count){
		$a = "$site\t$count\n";
		fwrite($fp,$a);
	}
	fclose($fp);
	@chmod($logfile,0666);
}

//==================================================================================
// Rebuild
// 再構築関係（キャッシュ及びRSSの作成）
//==================================================================================

//===============================================
// Create file cache
function GetFileList($dir,$skin_b,$skin_i,&$filelist,&$titlelist,&$dirlist){
	$num = 0;
	$fulldir = DIR_DATA.$dir;
	$h_dir = opendir(DIR_DATA.$dir);
	if(file_exists(DIR_DATA.$dir.FNAME_SKIN_BODY)) $skin_b = $dir;
	if(file_exists(DIR_DATA.$dir.FNAME_SKIN_ITEM)) $skin_i = $dir;
	while($file = readdir($h_dir)){
		$fullpath = DIR_DATA.$dir.$file;
		if(is_dir($fullpath)){
			if(!preg_match('/^\./',$file)){
				 $num += GetFileList($dir.$file.'/', $skin_b,$skin_i,$filelist,$titlelist,$dirlist);
			}
		}else if(preg_match('/'.EXT_DOCUMENT.'$/',$file)){
			$datafile = _file_get_contents($fullpath);
			$date=get_XMLTag(TAG_DATE,$datafile);
			if(!$date){
				$filelist[$dir.$file] = filectime($fullpath);
			}else{
				$filelist[$dir.$file] = w3cdtf_to_time($date);
			}
			$title = get_XMLTag(TAG_TITLE,$datafile);
			$title = preg_replace("/[\t\n\x0b\x0c\r]/",'',strip_tags($title));
			$titlelist[$dir.$file][FILELIST_TITLE]    = $title;
			$titlelist[$dir.$file][FILELIST_WBACCEPT] = get_XMLTag(TAG_WBACCEPT,$datafile);
			$num++;
		}
	}
	$dirlist[] = "$dir\t$num\t$skin_b\t$skin_i\n";
	return $num;
}
function CreateFileCache(){
	unset($filelist);
	unset($titlelist);
	unset($dirlist);
	GetFileList('','','',$filelist,$titlelist,$dirlist);

	if(sizeof($filelist)>0){
		arsort($filelist);
		$fp = _fopen_wb(FNAME_FILECACHE);
		foreach ($filelist as $fname => $date){
			$date = str_replace("\t",'',$date);
			$temp = "$fname\t$date\t".
				$titlelist[$fname][FILELIST_TITLE]."\t".
				$titlelist[$fname][FILELIST_WBACCEPT]."\n";
			fwrite($fp,$temp);
		}
		fclose($fp);
	}
	if(sizeof($dirlist)>0){
		sort($dirlist);
		$fp = _fopen_wb(FNAME_DIRCACHE);
		foreach ($dirlist as $temp) fwrite($fp,$temp);
		fclose($fp);
	}
}

function ReadFileCache(){
	global $g_dirlist,$g_filelist;
	if(file_exists(FNAME_DIRCACHE)){
		$dirlist = _file(FNAME_DIRCACHE);
		foreach($dirlist as $a){
			list($d0,$n0,$s_b,$s_i) = explode("\t",str_replace("\n",'',$a));
			$g_dirlist[$d0][DIRLIST_NUMITEM]   = $n0;
			$g_dirlist[$d0][DIRLIST_SKIN_BODY] = $s_b;
			$g_dirlist[$d0][DIRLIST_SKIN_ITEM] = $s_i;
		}
	}
	if(file_exists(FNAME_FILECACHE)){
		$filelist = _file(FNAME_FILECACHE);
		foreach($filelist as $a){
			list($fname,$date,$title,$wbaccept) = explode("\t",str_replace("\n",'',$a));
			$g_filelist[$fname][FILELIST_DATE] = $date;
			$g_filelist[$fname][FILELIST_TITLE] = $title;
			$g_filelist[$fname][FILELIST_WBACCEPT] = $wbaccept;
		}
	}
}

function FileCache_AddEntry($fname,$date,$title,$wbaccept){
	$filelist = _file(FNAME_FILECACHE);
	array_unshift($filelist,"$fname\t$date\t$title\t$wbaccept\n");	// add new entry
	$fp = _fopen_wb(FNAME_FILECACHE);
	foreach($filelist as $a) fwrite($fp,$a);
	fclose($fp);

	SplitPath($fname,$dir,$fn);
	$dirlist = _file(FNAME_DIRCACHE);
	$fp = _fopen_wb(FNAME_DIRCACHE);
	foreach($dirlist as $a){
		list($d0,$n0,$s_b,$s_i) = explode("\t",str_replace("\n",'',$a));
		if(ereg("^$dir",$d0)){
			$n0++; $a="$d0\t$n0\t$s_b\t$s_i\n";
		}
		fwrite($fp,$a);
	}
	fclose($fp);
}
function FileCache_DeleteEntry($fname){
	$filelist = _file(FNAME_FILECACHE);
	$fp = _fopen_wb(FNAME_FILECACHE);

	foreach($filelist as $a){
		list($fn0,$dt0,$ttl0,$wbf0) = explode("\t",str_replace("\n",'',$a));
		if($fn0!=$fname) fwrite($fp,$a);
	}
	fclose($fp);

	SplitPath($fname,$dir,$fn);
	$dirlist = _file(FNAME_DIRCACHE);
	$fp = _fopen_wb(FNAME_DIRCACHE);
	foreach($dirlist as $a){
		list($d0,$n0,$s_b,$s_i) = explode("\t",str_replace("\n",'',$a));
		if(ereg("^$dir",$d0)){
			$n0--; $a="$d0\t$n0\t$s_b\t$s_i\n";
		}
		fwrite($fp,$a);
	}
	fclose($fp);
}

//===============================================
// Create RSS

function GetDescription($buf,$len){
	$t = get_XMLTag(TAG_DESCRIPTION,$buf);
	if(!$t) $t = get_XMLTag(TAG_TEXT,$buf);
	$t = strip_tags($t);
	$t = preg_replace("/[\t\n\x0b\x0c\r]/",'',$t);
	$t = mb_ereg_replace(MB_DOUBLE_SPACE,'',$t);
	$trans = array('&amp;' => '&', '&quot;' => '"', '&lt;' => '<', '&gt;' => '>');
	$t = strtr($t, $trans);
	if(mb_strlen($t,SITE_CHARSET)>$len)
		 $t = mb_substr($t, 0, $len, SITE_CHARSET) . '...';
	$t = htmlspecialchars($t);	// & -> &amp; etc...
	return $t;
}

function CreateRSS(){
	if(!file_exists(FNAME_RSS))return;
	$a = CreateHTML(15,FNAME_SKIN_RSS,false);
	if(SITE_CHARSET!='UTF-8') $a = mb_convert_encoding($a,'UTF-8',"auto");
	$fp = _fopen_wb(FNAME_RSS);
	fwrite($fp,$a);
	fclose($fp);
}

//==================================================================================
// Build HTML
// HTML作成関係
//==================================================================================

// マクロ処理
function skin_macro(&$a,$fname='',$flag=''){
	global $g_bCellphone;
	$a = preg_replace("/<!---.*?--->\n?/s",'',$a);

	while(preg_match("/<IsCategory\s+dir=\"(.*?)\".*?>(.*?)<\/IsCategory>/s",$a,$opt)){
		$a = str_replace($opt[0],"<if category=\"".$opt[1]."\">".$opt[2]."</if>",$a);
	}
	while(preg_match("/<ifdef\s+tag=\"(.*?)\".*?>(.*?)<\/ifdef>/s",$a,$opt)){
		$a = str_replace($opt[0],"<if def_tag=\"".$opt[1]."\">".$opt[2]."</if>",$a);
	}
	while(preg_match("/<ifndef\s+tag=\"(.*?)\".*?>(.*?)<\/ifndef>/s",$a,$opt)){
		$a = str_replace($opt[0],"<if !def_tag=\"".$opt[1]."\">".$opt[2]."</if>",$a);
	}

	while(($pos_start=strpos($a,'<if '))!==false){
		$pos_end=$pos_start+1;
		$lv=0;
		while(true){
			if(preg_match('/^<if .*?>/s',substr($a,$pos_end))) $lv++;
			if(preg_match('/^<\/if\s*?>/s',substr($a,$pos_end),$tmp)){
				if($lv==0){
					$pos_end+=strlen($tmp[0]); break;
				}else{
					$lv--;
				}
			}
			$pos_end++;
		}
		$src=substr($a,$pos_start,$pos_end-$pos_start);
		if(!preg_match("/<if\s+(\S+)=\"(.*?)\".*?>(.*)<\/if.*?>/s",$src,$opt)){
			error(ERR_MSG_MACRO,ERR_FATAL);
		}
		$key=$opt[1];
		$value=$opt[2];
		$dst=$opt[3];
		$bFlag=false;
		$bNot=false;
		if(ereg("^!",$key)){
			$key=ereg_replace("^!",'',$key);
			$bNot=true;
		}
		switch($key){
		case 'category':
			if(ereg("^".$value,$_GET['u'])) $bFlag=true;
			break;
		case 'flag':
			switch($value){
			case 'bHome':
				if(($_GET['u']=='')&&($_GET['d']=='')) $bFlag = true;
				break;
			case 'bSingle':
				SplitPath($_GET['u'],$dir,$fn);
				if($fn) $bFlag = true;
				break;
			case 'bCellphone':
				$bFlag = $g_bCellphone;
				break;
			default;
				if(isset($flag[$value])) $bFlag = $flag[$value];
				break;
			}
			break;
		case 'mode':
			if($_GET['m']==$value) $bFlag = true;
			break;
		case 'def_tag':
			$entrybuf=FileGetEntries($fname);
			if(preg_match('/<'.$value.'.*?>/',$entrybuf)) $bFlag=true;
			break;
		}
		if($bNot=='!') if($bFlag) $bFlag=false; else $bFlag=true;
		if(!$bFlag) $dst='';
		$a = str_replace($src,$dst,$a);
	}

	while(preg_match("/<%goto\s+\"(.*?)\".*?%>/s",$a,$tmp)){
		$a = preg_replace("/".$tmp[0].".*<%label\s+\"".$tmp[1]."\".*?%>/s","",$a);
	}
	$a = preg_replace("/<%goto.*?%>/s",'',$a);
	$a = preg_replace("/<%label.*?%>/s",'',$a);

	$a = preg_replace("/\n\t*/s","\n",$a);
	$a = preg_replace("/\n+/s","\n",$a);
}

function SkinTagChk($tag,&$str,&$opt){
	$opt = '';
	if(! preg_match('/<%=\$'.$tag.'[[:space:]]*(.*?)%>/s',$str,$optstr)) return '';
	$tagstr = $optstr[0];
	$tmp = $optstr[1];
	if($tmp){
		$tmp=preg_replace("/[\t\r\n".REPLASE_CHAR."]/",'',$tmp);
		$tmp=preg_replace("/\\\\n/","\n",$tmp);
		while(ereg("\\\\(.)",$tmp,$t)){
			$tmp=str_replace($t[0],REPLASE_CHAR.sprintf("%02x",ord($t[1])),$tmp);
		}
		while(mb_ereg("\"([^\"]*)\"",$tmp,$t)){
			$t[1]=str_replace(' ',REPLASE_CHAR.'20',$t[1]);
			$t[1]=str_replace('=',REPLASE_CHAR.'3D',$t[1]);
			$tmp=str_replace($t[0],$t[1],$tmp);
		}
		$optlist = explode(' ',$tmp);
		for($i=0;$i<sizeof($optlist);$i++){
			list($key,$param) = explode('=',$optlist[$i]);
			while(ereg(REPLASE_CHAR.'(.{2})',$param,$t)){
				$param = str_replace($t[0],chr(hexdec($t[1])),$param);
			}
			$opt[$key]=$param;
		}
	}
	return $tagstr;
}

function MakeDateStr($date,$opt=''){
	if(isset($opt['fmt']))    $fmt   =$opt['fmt'];    else $fmt   =DATETIME_FORMAT;
	if(isset($opt['locale'])) $locale=$opt['locale']; else $locale=DATETIME_LOCALE;
	return strftime_jp($fmt,$date,$locale);
}

//===============================================
// １記事分のhtmlを作成

// 記事ファイル読み込み
function FileGetEntries($fname){
	static $EntryBuf = '';
	static $fname_sv = '';
	if($fname!=$fname_sv) $EntryBuf = ''; else $fname_sv=$fname;
	if($EntryBuf) return $EntryBuf;

	if(!file_exists(DIR_DATA.$fname)){
		return "<Content>".ERR_MSG_DELETEENTRY."</Content>";
	}
	$EntryBuf = _file_get_contents(DIR_DATA.$fname);
	$EntryBuf = preg_replace('/<%=.*?%>/s','',$EntryBuf);

	if(USE_MOD_REWRITE){
		SplitPath($_SERVER['PHP_SELF'],$base,$tmp);
	}else{
		$base = $_SERVER['PHP_SELF'].'?u=';
	}
	if(ereg("$site_link_full/",$EntryBuf)){
		$base = 'http://'.$_SERVER["HTTP_HOST"].$base;
		$EntryBuf=str_replace('$$site_link_full/',REPLASE_CHAR,$EntryBuf);		// no replace
		$EntryBuf=str_replace('$site_link_full/',$base,$EntryBuf);
		$EntryBuf=str_replace(REPLASE_CHAR,'$site_link_full/',$EntryBuf);
	}
	if(ereg("$site_link/",$EntryBuf)){
		$EntryBuf=str_replace('$$site_link/',REPLASE_CHAR,$EntryBuf);		// no replace
		$EntryBuf=str_replace('$site_link/',$base,$EntryBuf);
		$EntryBuf=str_replace(REPLASE_CHAR,'$site_link/',$EntryBuf);
	}
	return $EntryBuf;
}

// 携帯用・imgタグを変換
function imgtag_chg_on_cellphone(&$a){
	global $g_bCellphone;
	if(!$g_bCellphone) return;

	while(preg_match("/<a\s.*?>.*?<img\s.*?>.*?<\/a.*?>/s",$a,$opt)){
		$rep=$opt[0];
		while(preg_match("/<img\s.*?src=\"(.*?)\".*?>/s",$rep,$opt2)){
			$fname = preg_replace("/^.*\//",'',$opt2[1]);
			$rep = str_replace($opt2[0],"[$fname]",$rep);
		}
		$rep = str_replace('<',REPLASE_CHAR,$rep);
		$a = str_replace($opt[0],$rep,$a);
	}
	while(preg_match("/<img\s.*?src=\"(.*?)\".*?>/s",$a,$opt2)){
		$fname = preg_replace("/^.*\//",'',$opt2[1]);
		$a = str_replace($opt2[0],"<a href=\"".$opt2[1]."\">[$fname]</a>",$a);
	}
	$a = str_replace(REPLASE_CHAR,'<',$a);
}

function WriteBack_WBTB($log_data,$fmt,$bTB){
	$no=1;
	$rep='';
	foreach($log_data as $a){
		list ($name,$email,$text,$date,$blog_name,$mode) = explode("\t",str_replace("\n","",$a));
		if($mode=='tb') $bTB0=true; else $bTB0=false;
		if($bTB==$bTB0){
			$url='';
			if($email){	// urlとe-mail が併記されてたら分離
				if(preg_match(LINK_REP_STR,$email,$tmp)) $url=$tmp[1].$tmp[2];
				$email = preg_replace(LINK_REP_STR,'',$email);
				$email = preg_replace("/(^ *| *$)/",'',$email);
				$email = str_replace("@",MEASURES_FOR_SPAM,$email);	// spam対策
			}
			if($url) $name = "<a href=\"$url\">$name</a>";
			if($blog_name) $name = "$blog_name/$name";
			$datestr = MakeDateStr($date);

			$fmt_tmp = $fmt;
			$fmt_tmp=str_replace('$no',$no,$fmt_tmp);
			$fmt_tmp=str_replace('$name',$name,$fmt_tmp);
			$fmt_tmp=str_replace('$date',$datestr,$fmt_tmp);
			$fmt_tmp=str_replace('$email',$email,$fmt_tmp);
			$fmt_tmp=str_replace('$text',autolink($text),$fmt_tmp);

			$rep .= $fmt_tmp;
			$no++;
		}
	}
	return $rep;
}
function WriteBack_Ref($ref_data,$fmt){
	$rep='';
	for($i=0;$i<min(15,sizeof($ref_data));$i++){
		list($site,$count) = explode("\t",str_replace("\n","",$ref_data[$i]));
		$fmt_tmp = $fmt;
		$fmt_tmp=str_replace('$no',$i+1,$fmt_tmp);
		$fmt_tmp=str_replace('$url',$site,$fmt_tmp);
		$fmt_tmp=str_replace('$num',$count,$fmt_tmp);
		$rep .= $fmt_tmp;
	}
	return $rep;
}

// ITEM用スキン処理・本体
function GetContentsEach($fname,$skin,$bSingle){
	global $g_filelist,$g_dirlist,$category_name,$g_bCellphone;

	// read skin file
	SplitPath($fname,$dir,$fn0);
	if(($skin=='')&&($g_bCellphone)){
		$skin = DIR_DATA.ext_change(FNAME_SKIN_ITEM,'_i'.FNAME_SKIN_EXT);
		if(!file_exists($skin)) $skin = '';
	}
	if($skin==''){
		$skin = DIR_DATA.$g_dirlist[$dir][DIRLIST_SKIN_ITEM].FNAME_SKIN_ITEM;
	}
	$a = _file_get_contents($skin);

	while($tagstr=SkinTagChk('WriteBack',$a,$opt)){
		$skin = $opt['skin'];
		if(!$skin) $skin = FNAME_SKIN_WRITEBACK;
		$a=str_replace($tagstr,_file_get_contents($skin),$a);
	}

	unset($buf);	// entry buffer;

	// macro
	$iAccept = IsWBAccept($fname);
	$logfile = DIR_DATA.ext_change($fname,EXT_LOGFILE);
	$ref_log = DIR_DATA.ext_change($fname,FNAME_REFERER);
	$bLogExist = file_exists($logfile);
	$bRefExist = file_exists($ref_log);
	$numtb = 0;
	$numwb = 0;
	$numrf = 0;
	if($bLogExist){
		$log_data = _file($logfile);
		foreach($log_data as $d0){
			list ($name,$url,$com,$times,$title,$mode) = explode("\t",str_replace("\n","",$d0));
			if($mode=='tb') $numtb ++; else $numwb++;
		}
	}
	if($bRefExist){
		$ref_data = _file($ref_log);
    	$numrf = sizeof( $ref_data );
	}

	$flag['bAccept'] = false;
	$flag['bTimeout'] = false;
	if($iAccept==WB_FLAG_ACCEPT){
		$flag['bAccept'] = true;
	}elseif($iAccept==WB_FLAG_TIMEOVER){
		$flag['bTimeout'] = true;
	}
	$flag['bWBExist'] = false;
	$flag['bTBExist'] = false;
	if($numwb>0) $flag['bWBExist'] = true;
	if($numtb>0) $flag['bTBExist'] = true;
	$flag['bRefExist'] = $bRefExist;

    skin_macro($a,$fname,$flag);

	if(! preg_match("/\S/s",$a)) return '';

	// replacement
	while($tagstr=SkinTagChk('Url',$a,$opt)){
		$m0='';
		if(isset($opt['mode'])) $m0 = array('m'=>$opt['mode']);
		$a=str_replace($tagstr,MakeLinkUrl($fname,$m0,$opt['fullpath']),$a);
	}
	while($tagstr=SkinTagChk(TAG_DATE,$a,$opt)){
		$a=str_replace($tagstr,MakeDateStr($g_filelist[$fname][FILELIST_DATE],$opt),$a);
	}
	while($tagstr=SkinTagChk(TAG_TITLE,$a,$opt)){
		$a=str_replace($tagstr,$g_filelist[$fname][FILELIST_TITLE],$a);
	}
	while($tagstr=SkinTagChk('Category',$a,$opt)){
		$dd = explode("/",$dir);
		$cn = '';
		if(sizeof($dd)>1){
			foreach($dd as $dd) if($dd){
				if(isset($category_name[$dd])) $dd=$category_name[$dd];
				$cn .= '/'.$dd;
			}
		}else{
			if(isset($category_name[''])) $cn=$category_name['']; else $cn='Home';
		}
		$a=str_replace($tagstr,preg_replace('/^\//','',$cn),$a);
	}
	while($tagstr=SkinTagChk(TAG_DESCRIPTION,$a,$opt)){
		if(!isset($buf)) $buf=FileGetEntries($fname);
		$len = MAX_DESCRIPTION;
		if(isset($opt['length'])) $len = $opt['length'];
		$a=str_replace($tagstr,GetDescription($buf,$len),$a);
	}

	// WriteBack
	while($tagstr=SkinTagChk('NumWB',$a,$opt)) $a=str_replace($tagstr,$numwb,$a);
	while($tagstr=SkinTagChk('NumTB',$a,$opt)) $a=str_replace($tagstr,$numtb,$a);
    while($tagstr=SkinTagChk('NumRF',$a,$opt)) $a=str_replace($tagstr,$numrf,$a);

	while($tagstr=SkinTagChk('WB_Data',$a,$opt)){
		$rep='';
		if(($numwb>0)&&(isset($opt['fmt']))) $rep=WriteBack_WBTB($log_data,$opt['fmt'],false);
		$a=str_replace($tagstr,$rep,$a);
	}
	while($tagstr=SkinTagChk('TB_Data',$a,$opt)){
		$rep='';
		if(($numtb>0)&&(isset($opt['fmt']))) $rep=WriteBack_WBTB($log_data,$opt['fmt'],true);
		$a=str_replace($tagstr,$rep,$a);
	}
	while($tagstr=SkinTagChk('Ref_Data',$a,$opt)){
		$rep='';
		if(($bRefExist)&&(isset($opt['fmt']))) $rep=WriteBack_Ref($ref_data,$opt['fmt']);
		$a=str_replace($tagstr,$rep,$a);
	}
	while($tagstr=SkinTagChk('bbs_delete_id',$a,$opt)) $a=str_replace($tagstr,ext_change($fname,''),$a);

	// Other Tags
	while(preg_match('/<%=\$(.+?)%>/s',$a,$tmp)){
		$tagname = explode(' ',$tmp[1]);
		if(!isset($buf)) $buf=FileGetEntries($fname);
		$tagstr = SkinTagChk($tagname[0],$a,$opt);
		$rep = get_XMLTag($tagname[0],$buf);
		if($rep==''){
			$rep = REPLASE_CHAR.substr($tagstr,2);
		}else{
			if(bool_opt_chk($opt['autolink'],false)){
				$rep = autolink($rep);
			}
			if(bool_opt_chk($opt['targetblank'],false)){
				$rep = preg_replace("/(<a\s.*?https?:\/\/.*?)>/s","\\1 target=\"_blank\">",$rep);
			}
			imgtag_chg_on_cellphone($rep);
		}
		$a = str_replace($tagstr,$rep,$a);
	}
	$a = str_replace(REPLASE_CHAR,'<%',$a);
	return $a;
}

//===============================================
// 必要な記事のリストを抽出

define(INFO_FLIST,0);
define(INFO_DIR,1);
define(INFO_PAGE,2);
define(INFO_NUM,3);
define(INFO_TOTAL,4);
define(INFO_ISSINGLE,5);
define(INFO_DATE,6);
define(INFO_SORT,7);
define(DATA_NO_SET,"\x07");

function SortFileByCommentTime($sort,&$fi){
	global $g_filelist;
	unset($lst);
	if(sizeof($fi[INFO_FLIST])<=1)return;
	foreach($fi[INFO_FLIST] as $fname){
		$lst[$fname] = $g_filelist[$fname][FILELIST_DATE];
		$logfile = DIR_DATA.ext_change($fname,EXT_LOGFILE);
		if( ! file_exists( $logfile ) ) continue;

		$log_data = _file($logfile);
		$d0 = end( $log_data );
		if( ! $d0 ) continue;

		list ($name,$url,$com,$times,$title,$mode) = explode("\t",str_replace("\n","",$d0));
		if( $times > $lst[$fname] ) $lst[$fname] = $times;
	}
	switch($sort){
	case 'cf': asort($lst);break;		// comment time - forward
	case 'cr': arsort($lst);break;		// comment time - reverse
	}
	unset($fi[INFO_FLIST]);
	foreach($lst as $fname => $d0) $fi[INFO_FLIST][] = $fname;
}

function SelectFileList($url,$date,$page,$num,$sort){
	global $g_filelist,$nodisp_at_toplv;
	$u = $_GET['u'];
	$p = $_GET['p'];
	$d = $_GET['d'];

	if($url ==DATA_NO_SET) $url=$u;
	if($date==DATA_NO_SET) $date=$d;
	if((string)$page==DATA_NO_SET) $page=$p;

	$url = ereg_replace('^/','',$url);
	$date= ereg_replace('^-','',$date);
	SplitPath($url,$dir,$fn);
	$fi[INFO_DIR]=$dir;
	$fi[INFO_PAGE]=(int)$page;
	$fi[INFO_TOTAL]=0;
	$fi[INFO_NUM]=$num;
	$fi[INFO_ISSINGLE] = false;
	$fi[INFO_DATE] = $date;
	$fi[INFO_SORT] = $sort;
	unset($fi[INFO_FLIST]);

	if(! is_array($g_filelist)) return $fi;		// no file;

	$flisttmp = $g_filelist;	// default:day - reverse
	switch($sort){
	case 'df': $flisttmp = array_reverse($flisttmp);break;	// day-forward
	case 'ff': ksort($flisttmp);break;						// fname-forward
	case 'fr': krsort($flisttmp);break;						// fname-reverse
	}

	if($fn){
		$fi[INFO_ISSINGLE] = true;
		$fi[INFO_NUM]=1;
		if(FORTHBACKMODE) $d0=ereg_replace('/.*$','',$dir); else $d0='';
		foreach ($flisttmp as $fname => $lst){
			if(ereg("^$d0",$fname)) $fi[INFO_FLIST][]=$fname;
		}
	}else{
		if($num==1){
			$fi[INFO_ISSINGLE] = true;
		}
		foreach ($flisttmp as $fname => $lst){
			if(ereg("^$dir",$fname)){
				$bDisp=true;
				if(($dir=='')&&(is_array($nodisp_at_toplv))){
					foreach($nodisp_at_toplv as $a){
						if(ereg("^$a",$fname)) $bDisp=false;
					}
				}
				if($bDisp){
					if(!$date){
						$fi[INFO_FLIST][]=$fname;
					}else{
						if(ereg("^$d",(date('Y-m-d',$lst[FILELIST_DATE])))) $fi[INFO_FLIST][]=$fname;
					}
				}
			}
		}
	}
	$fi[INFO_TOTAL]=sizeof($fi[INFO_FLIST]);

	// cr,cf: comment time sort
	if(($sort=='cr')||($sort=='cf')) SortFileByCommentTime($sort,$fi);

	if($fn){
		$fi[INFO_PAGE] = array_search( ext_change($url,EXT_DOCUMENT), $fi[INFO_FLIST] );
	}
	return $fi;
}

//===============================================
// 前後移動ナビ

function Navi_ForthBack_Sub(&$fi,&$prev_title,&$prev_url,&$next_title,&$next_url){
	global $g_filelist;
	$prev_title = $prev_url = $next_title = $next_url = '';
	if($fi[INFO_ISSINGLE]){
		if($fi[INFO_PAGE]+1<$fi[INFO_TOTAL]){
			$fn0 = $fi[INFO_FLIST][$fi[INFO_PAGE]+1];
			$prev_url   = MakeLinkUrl($fn0);
			$prev_title = $g_filelist[$fn0][FILELIST_TITLE];
		}
		if($fi[INFO_PAGE]>0){
			$fn0 = $fi[INFO_FLIST][$fi[INFO_PAGE]-1];
			$next_url   = MakeLinkUrl($fn0);
			$next_title = $g_filelist[$fn0][FILELIST_TITLE];
		}
	}else{
		if(($fi[INFO_PAGE]+1)*$fi[INFO_NUM]<$fi[INFO_TOTAL]){
			$s0 = ($fi[INFO_PAGE]+1)*$fi[INFO_NUM] + 1;
			$e0 = min($s0+$fi[INFO_NUM]-1,$fi[INFO_TOTAL]);
			$prev_url   = MakeLinkUrl($fi[INFO_DIR],array('p'=>($fi[INFO_PAGE]+1),'d'=>$fi[INFO_DATE]));
			$prev_title = $s0;
			if($e0>$s0) $prev_title .= '-'.$e0;
		}
		if($fi[INFO_PAGE]*$fi[INFO_NUM]>0){
			$s0 = ($fi[INFO_PAGE]-1)*$fi[INFO_NUM] + 1;
			$e0 = min($s0+$fi[INFO_NUM]-1,$fi[INFO_TOTAL]);
			$next_url   = MakeLinkUrl($fi[INFO_DIR],array('p'=>($fi[INFO_PAGE]-1),'d'=>$fi[INFO_DATE]));
			$next_title  = $s0;
			if($e0>$s0) $next_title .= '-'.$e0;
		}
	}
	if(($fi[INFO_SORT]=='ff')||($fi[INFO_SORT]=='df')){
		SwapData($prev_title,$next_title);
		SwapData($prev_url,$next_url);
	}
}

function Navi_ForthBack(&$fi,$opt){
	global $g_filelist,$g_dirlist,$category_name;

	$dir = $fi[INFO_DIR];
	if($fi[INFO_ISSINGLE]){
		if(FORTHBACKMODE) $dir=ereg_replace('/.*$','',$dir); if($dir) $dir.='/';
	}
	$rep = '';

	// link rel
	if($opt['mode']=='link'){
		$rep .= '<link rel="top" href="'.MakeLinkUrl().'" />'."\n";;
		if($fi[INFO_TOTAL]>$fi[INFO_NUM]){
			Navi_ForthBack_Sub($fi,$prev_title,$prev_url,$next_title,$next_url);
			if($prev_url) $rep .= '<link rel="prev" href="'.$prev_url.'" title="'.$prev_title.'" />'."\n";
			if($next_url) $rep .= '<link rel="next" href="'.$next_url.'" title="'.$next_title.'" />';
		}
		return $rep;
	}

	// button only
	if(($opt['mode']=='prev')||($opt['mode']=='next')){
		if($fi[INFO_TOTAL]<=$fi[INFO_NUM]) return '';
		Navi_ForthBack_Sub($fi,$prev_title,$prev_url,$next_title,$next_url);
		if((($opt['mode']=='prev')&&(!$prev_url))||(($opt['mode']=='next')&&(!$next_url))) return '';
		if($opt['mode']=='prev') $rep .= "<a href=\"$prev_url\" title=\"$prev_title\"";
		if($opt['mode']=='next') $rep .= "<a href=\"$next_url\" title=\"$next_title\"";
		if($opt['id']) $rep .= " id=\"".$opt['id']."\"";
		if($opt['class']) $rep .= " class=\"".$opt['class']."\"";
		$rep .= ">";
		if(isset($opt['str'])){
			$rep .= $opt['str'];
		}else{
			if($opt['mode']=='prev') $rep .= "« ".$prev_title; else $rep .= $next_title." »";
		}
		$rep .= "</a>";
		return $rep;
	}

	// Category name
	$d0 = explode("/",$dir);
	if(isset($category_name[''])) $cn=$category_name['']; else $cn='Home';
	$category = '<a href="'.MakeLinkUrl().'">'.$cn.'</a>';
	$dd = '';
	foreach($d0 as $a) if($a){
		$cn = $a; if(isset($category_name[$cn])) $cn=$category_name[$cn];
		$dd .= $a.'/';
		$category .= '/<a href="'.MakeLinkUrl($dd).'">'.$cn.'</a>';
	}
	if($opt['mode']=='category') return $category;

	// normal
	if($opt['mode']!='compact') $rep .= '<p>';
	if(!$fi[INFO_DATE] || sizeof($d0)>1){
		if($opt['mode']!='compact') $rep .= 'Category:';
		$rep .= $category;
	}
	if($fi[INFO_DATE]){
		$rep .= ' ';
		if($opt['mode']!='compact') $rep .= 'Date:';
		$d0 = explode("-",$fi[INFO_DATE]);
		$dd = '';
		$i=1;
		foreach($d0 as $a) if($a){
			$cn = $a; if(($i<3)&&(isset($category_name[$cn]))) $cn=$category_name[$cn];
			$dd .= $a;
			$rep .= '<a href="'.MakeLinkUrl($dir,array('d'=>$dd)).'">'.$cn.'</a>';
			if($i<sizeof($d0)){ $dd .= '-'; $rep.='/'; }
			$i++;
		}
	}
	if($opt['mode']!='compact')
		$rep .= ' (Total '.$fi[INFO_TOTAL]." items)</p>\n";
	else
		$rep .= '('.$fi[INFO_TOTAL].")<br>\n";

	if($fi[INFO_TOTAL]>$fi[INFO_NUM]){
		Navi_ForthBack_Sub($fi,$prev_title,$prev_url,$next_title,$next_url);
		$next_title = $next_title.' »';
		$prev_title = '« '.$prev_title;
		if($opt['mode']!='compact') $rep .= '<p>';
		if($fi[INFO_ISSINGLE]){
			if(isset($opt['prev_str'])) $prev_title = $opt['prev_str'];
			if(isset($opt['next_str'])) $next_title = $opt['next_str'];
			if($prev_url) $rep .= '<a href="'.$prev_url.'">'.$prev_title.'</a>';
			$rep .= ' | ';
			if($next_url) $rep .= '<a href="'.$next_url.'">'.$next_title.'</a>';
		}else{
			if($prev_url) $rep .= '<a href="'.$prev_url.'">'.$prev_title.'</a> | ';
			$s0 = ($fi[INFO_PAGE])*$fi[INFO_NUM] + 1;
			$e0 = min($s0+$fi[INFO_NUM]-1,$fi[INFO_TOTAL]);
			$rep .= $s0;
			if($e0>$s0) $rep .= '-'.$e0;
			if($next_url) $rep .= ' | <a href="'.$next_url.'">'.$next_title.'</a>';
		}
		if($opt['mode']!='compact') $rep .= "</p>";
	}
	return $rep;
}

//===============================================
// キャッシュ制御

function cache_getquery(){
	unset($q);
	if($_GET['u']) $q[]='u='.$_GET['u'];		// url
	if($_GET['d']) $q[]='d='.$_GET['d'];		// date
	if($_GET['p']) $q[]='p='.$_GET['p'];		// page
	if($_GET['s']) $q[]='s='.$_GET['s'];		// skin
	if($_GET['c']) $q[]='c='.$_GET['c'];		// content-type
	if($_GET['m']) $q[]='m='.$_GET['m'];		// mode
	if($_GET['mode']) $q[]='m='.$_GET['mode'];		// system mode
	$ret='';
	if(is_array($q)) $ret=implode('&',$q);
	return $ret;
}

function cache_read(){
	global $g_LastModified;
	$query = cache_getquery();
	$fname = 'cache_'.md5($query.$g_LastModified).'.cache';
	$num=0;

	// 存在する？
	if(! file_exists(DIR_CACHE.$fname)) return '';

	// リスト更新
	$fp = @fopen(FNAME_CACHELIST,"r+b");
	if($fp){
		set_file_buffer($fp, 0);
		flock($fp, LOCK_EX);
		rewind($fp);
		unset($cachelist);
		while(!feof($fp)) $cachelist[]=fgets($fp,4096);
		foreach($cachelist as $a){
			list($t0,$f0,$q0) = explode("\t",str_replace("\n",'',$a));
			if($f0==$fname) break;
			$num++;
		}
		if($num>0){
			SwapData($cachelist[$num],$cachelist[$num-1]);
			ftruncate($fp,0);
			rewind($fp);
			foreach($cachelist as $aa) fwrite($fp,$aa);
		}
		fclose($fp);
	}
	return @file_get_contents(DIR_CACHE.$fname);
}

function cache_write($cachedata){
	global $g_config,$g_LastModified;
	$query = cache_getquery();
	$fname = 'cache_'.md5($query.$g_LastModified).'.cache';

	// リスト更新
	$newlist = implode("\t",array($g_LastModified,$fname,$query))."\n";
	if(! file_exists(FNAME_CACHELIST)){
		$fp = _fopen_wb(FNAME_CACHELIST);
		fwrite($fp,$newlist);
		fclose($fp);
	}else{
		$fp = @fopen(FNAME_CACHELIST,"r+b");
		if(!$fp) return;
		set_file_buffer($fp, 0);
		flock($fp, LOCK_EX);
		rewind($fp);
		unset($cachelist);
		while(!feof($fp)) $cachelist[]=fgets($fp,4096);
		ftruncate($fp,0);
		rewind($fp);
		$num=0;
		$bAdd=false;
		foreach($cachelist as $a)if($a){
			list($t0,$f0,$q0) = explode("\t",str_replace("\n",'',$a));
			if(($num+1<$g_config['cache_pages_max'])&&($t0>=$g_LastModified)){
				fwrite($fp,$a);
				if($num==$g_config['cache_pages_max']/2-1){
					fwrite($fp,$newlist);
					$bAdd=true;
				}
				$num++;
			}else{
				@unlink(DIR_CACHE.$f0);
			}
		}
		if(!$bAdd) fwrite($fp,$newlist);
		fclose($fp);
	}

	// キャッシュ作成
	$fp = _fopen_wb(DIR_CACHE.$fname);
	fwrite($fp,$cachedata);
	fclose($fp);
}

function cache_clean(){
	$h_dir = opendir(DIR_CACHE);
	while($fname = readdir($h_dir)){
		if(preg_match("/[0-9a-f]{32}\.cache/",$fname)) @unlink(DIR_CACHE.$fname);	// この行将来削除
		if(preg_match("/cache_[a-f\d]{32}\.cache/",$fname)) @unlink(DIR_CACHE.$fname);
	}
	@unlink(FNAME_CACHELIST);
}

//===============================================
// 以下、BODY用スキン処理関係

function Site_EntryTitle(){
	global $g_filelist,$category_name;
	$u = $_GET['u'];
	$d = $_GET['d'];

	if($u){
		$fn0 = str_replace(EXT_ACCESS,EXT_DOCUMENT,$u);
		if(isset($g_filelist[$fn0])){
			$rep = $g_filelist[$fn0][FILELIST_TITLE];
		}else{
			$dd = explode("/",$u);
			$rep = '';
			if(sizeof($dd)>1){
				foreach($dd as $dd) if($dd){
					if(isset($category_name[$dd])) $dd=$category_name[$dd];
					$rep .= '/'.$dd;
				}
			}
			$rep = preg_replace('/^\//','',$rep);
		}
	}elseif($d){
		$rep = $d;
	}
	if($rep) return ' - '.$rep; else return '';
}

function Plugin($name,$func,$opt){
	static $g_plugin = '';
	require_once(DIR_PLUGINS.$name.'.php');
	if(!isset($g_plugin[$name])){
		$g_plugin[$name] = new $name;
	}
	return $g_plugin[$name]->$func($opt);
}

function CreateHTML($num,$skin_body,$bCacheEnable){
	global $g_filelist,$nodisp_at_toplv;

	$a='';
	if(($bCacheEnable)&&(file_exists(FNAME_CACHELIST))){
		$a = cache_read();
	}
	if(!$a){
		$a = _file_get_contents($skin_body);
		unset($fi);
		while($tagstr=SkinTagChk('include',$a,$opt)){
			$rep = '';
			if(isset($opt['url'])) $rep = _file_get_contents($opt['url']);
			$a=str_replace($tagstr,$rep,$a);
		}
		skin_macro($a);

		while($tagstr=SkinTagChk('site_items',$a,$opt)){
			$n0 = $num;
			$s0 = '';
			$u0 = DATA_NO_SET;
			$d0 = DATA_NO_SET;
			$p0 = DATA_NO_SET;
			$sort = 'dr';	// day-reverse
			if(isset($opt['num'])) $n0 = $opt['num'];
			if(isset($opt['sort'])) $sort = $opt['sort'];
			if(isset($opt['skin'])) $s0 = ext_change($opt['skin'],FNAME_SKIN_EXT);
			if(isset($opt['url'])||isset($opt['date'])){
				$u0=''; $d0=''; $p0=0;
				if(isset($opt['url'] )) $u0 = $opt['url'];
				if(isset($opt['date'])) $d0 = $opt['date'];
			}
			$fi0 = SelectFileList($u0,$d0,$p0,$n0,$sort);

			unset($bbs_dir);
			if((!isset($opt['url']))&&(!isset($opt['date']))){
				$fi = $fi0;
			}
			$rep = '';
			$loop_start = $fi0[INFO_PAGE] * $fi0[INFO_NUM];
			$loop_end   = min($loop_start+$fi0[INFO_NUM],$fi0[INFO_TOTAL]);
			$count=1;
			$start = 0;
			$end = 0;
			if(isset($opt['start'])) $start=$opt['start'];
			if(isset($opt['end'])){ $end=$opt['end']; $loop_end=$fi0[INFO_TOTAL]; }
			for($i=$loop_start; $i<$loop_end; $i++){
				$data = GetContentsEach($fi0[INFO_FLIST][$i],$s0,$fi0[INFO_ISSINGLE]);
				if($data){
					if(($start==0)||($count>=$start)) $rep .= $data;
					$count++; if(($end!=0)&&($count>$end)) break;
				}
			}
			$a=str_replace($tagstr,$rep,$a);
		}

		while($tagstr=SkinTagChk('navi_forthback',$a,$opt)){
			if(isset($fi)) $rep=Navi_ForthBack($fi,$opt); else $rep = '';
			$a=str_replace($tagstr,$rep,$a);
		}

		while($tagstr=SkinTagChk('last_modified',$a,$opt)){
			$t0 = time();
			if(is_array($g_filelist)){
				foreach($g_filelist as $fn => $lst){
					$bDisp=true;
					if(is_array($nodisp_at_toplv)){
						foreach($nodisp_at_toplv as $d0) if(ereg("^$d0",$fn)) $bDisp=false;
					}
					if($bDisp) break;
				}
				$t0 = $g_filelist[$fn][FILELIST_DATE];
			}
			$a=str_replace($tagstr,MakeDateStr($t0,$opt),$a);
		}
		while($tagstr=SkinTagChk('site_link',$a,$opt)){
			$u0=$d0=$s0=$c0=$m0='';
			if(isset($opt['url']))  $u0 = $opt['url'];
			if(isset($opt['date'])) $d0 = $opt['date'];
			if(isset($opt['skin'])) $s0 = $opt['skin'];
			if(isset($opt['type'])) $c0 = $opt['type'];
			if(isset($opt['mode'])) $m0 = $opt['mode'];
			$a=str_replace($tagstr,
				MakeLinkUrl($u0,array('d'=>$d0,'s'=>$s0,'c'=>$c0,'m'=>$m0),$opt['fullpath']),$a);
		}
		while($tagstr=SkinTagChk('site_base',$a,$opt)){
			SplitPath($_SERVER['PHP_SELF'],$base,$tmp);
			$a=str_replace($tagstr,'http://'.$_SERVER["HTTP_HOST"].$base,$a);
		}
		while($tagstr=SkinTagChk('rss_url',$a,$opt)){
			SplitPath($_SERVER['PHP_SELF'],$base,$tmp);
			$a=str_replace($tagstr,'http://'.$_SERVER["HTTP_HOST"].$base.FNAME_RSS,$a);
		}
		while($tagstr=SkinTagChk('site_title',$a,$opt))		$a=str_replace($tagstr,SITE_TITLE,$a);
		while($tagstr=SkinTagChk('site_entrytitle',$a,$opt))$a=str_replace($tagstr,Site_EntryTitle(),$a);
		while($tagstr=SkinTagChk('site_url',$a,$opt))		$a=str_replace($tagstr,SITE_URL,$a);
		while($tagstr=SkinTagChk('site_charset',$a,$opt))	$a=str_replace($tagstr,SITE_CHARSET,$a);
		while($tagstr=SkinTagChk('site_lang',$a,$opt))		$a=str_replace($tagstr,SITE_LANG,$a);
		while($tagstr=SkinTagChk('site_author',$a,$opt))	$a=str_replace($tagstr,SITE_AUTHOR,$a);
		while($tagstr=SkinTagChk('rnote_version',$a,$opt))	$a=str_replace($tagstr,RNOTE_VERSION,$a);
		while($tagstr=SkinTagChk('rnote_url',$a,$opt))		$a=str_replace($tagstr,RNOTE_URL,$a);

		// bbs
		SplitPath($_GET['u'],$dir,$fname);
		$bbs_posturl = MakeLinkUrl($dir);
		while($tagstr=SkinTagChk('bbs_posturl',$a,$opt)) $a=str_replace($tagstr,$bbs_posturl,$a);

		// plugins
		while($tagstr=SkinTagChk('plugin',$a,$opt)){
			if(bool_opt_chk($opt['cache'],true)){
				if(isset($opt['name'])){
					if(! isset($opt['func'])) $opt['func']='exec';
					$a=str_replace($tagstr,Plugin($opt['name'],$opt['func'],$opt['opt']),$a);
				}
			}else{
				$a=str_replace($tagstr,str_replace('<',REPLASE_CHAR,$tagstr),$a);
			}
		}
		$a=str_replace(REPLASE_CHAR,'<',$a);

		while($tagstr=SkinTagChk('navi_category',$a,$opt)){
			$a=str_replace($tagstr,Plugin('navitools','category',''),$a);
		}
		while($tagstr=SkinTagChk('navi_archive',$a,$opt)){
			$a=str_replace($tagstr,Plugin('navitools','archive',''),$a);
		}
		while($tagstr=SkinTagChk('navi_calendar',$a,$opt)){
			$a=str_replace($tagstr,Plugin('navitools','calendar',''),$a);
		}

		if($bCacheEnable) cache_write($a);
	}

	// bbs, writeback
	$cookie = $_COOKIE[COOKIE_WRITEBACK];
	if(FORM_CONVENC_AUTO) $cookie = mb_convert_encoding($cookie,SITE_CHARSET,"auto");
	list($ck_name,$ck_url,$ck_pass) = explode("\t", $cookie);
	while($tagstr=SkinTagChk('cookie_name',$a,$opt)) $a=str_replace($tagstr,$ck_name,$a);
	while($tagstr=SkinTagChk('cookie_url',$a,$opt)) $a=str_replace($tagstr,$ck_url,$a);
	while($tagstr=SkinTagChk('cookie_pass',$a,$opt)) $a=str_replace($tagstr,$ck_pass,$a);

	// plugins (no-cache)
	while($tagstr=SkinTagChk('plugin',$a,$opt)){
		if(isset($opt['name'])){
			if(! isset($opt['func'])) $opt['func']='exec';
			$a=str_replace($tagstr,Plugin($opt['name'],$opt['func'],$opt['opt']),$a);
		}
	}

	// finalize
	$a = preg_replace('/<%=.*?%>/s','',$a);
	if(USE_MOD_REWRITE) ChangeFullUrl($a);
	return $a;
}

//==================================================================================
// Startup
// プログラム開始
//==================================================================================

//===============================================
// Administrator mode
function login_check(){
	if(($_GET['mode']=='admin')&&(!$_POST['savecookie'])) setcookie(COOKIE_LOGIN_ID_PASS, '');
	if(($_POST['PHP_AUTH_USER']==ADMIN_ID)&&($_POST['PHP_AUTH_PW']==ADMIN_PASSWORD)){
		if($_POST['savecookie']){
			setcookie(COOKIE_LOGIN_ID_PASS, implode("\t",array(ADMIN_ID,ADMIN_PASSWORD)), time()+2*7*24*3600);
		}
		return;
	}
	if(($_POST['PHP_AUTH_USER']!='')||($_POST['PHP_AUTH_PW']!='')) error(ERR_MSG_PASSWORD);

	$a = '';
	$bSaveCookie = $ck_id = $ck_pass = '';
	if($_COOKIE[COOKIE_LOGIN_ID_PASS]){
		$bSaveCookie = 'checked="checked" ';
		list($ck_id,$ck_pass) = explode("\t", $_COOKIE[COOKIE_LOGIN_ID_PASS]);
	}
	$a .= "<html><body>\n<h1>rNote Login</h1>\n";
	$a .= "<form method=\"post\" action=\"".MakeLinkUrl()."\">\n";
	$a .= "<input type=\"hidden\" name=\"mode\" value=\"admin\"/>\n";
	$a .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
	$a .= "<tr><td>ID: </td><td><input type=\"text\" name=\"PHP_AUTH_USER\" size=\"60\" maxlength=\"100\" value=\"$ck_id\" /></td></tr>\n";
	$a .= "<tr><td>PASS: </td><td><input type=\"password\" name=\"PHP_AUTH_PW\" size=\"60\" maxlength=\"100\" value=\"$ck_pass\" /></td></tr>\n";
	$a .= "<tr><td colspan=\"2\"><input type=\"checkbox\" name=\"savecookie\" value=\"1\" $bSaveCookie/> ".MSG_LOGIN_COOKIE."</td></tr>\n";
	$a .= "<tr><td colspan=\"2\"><input type=\"submit\" value=\"Login\" /></td></tr>\n";
	$a .= "</table></form>\n";
	$a .= "</body></html>\n";

	header(CONTENT_TYPE_HTML);
	print $a;
	exit;
}
function AdminMode(){
	global $g_filelist;
	login_check();
	cache_clean();
	CreateFileCache();
	ReadFileCache();
	if(is_array($g_filelist)) CreateRSS();
	header(CONTENT_TYPE_HTML);
	print "<html><body>\n";
	print "<p>".MSG_REBUILD."</p>\n";
	print "<form method=\"post\" action=\"".MakeLinkUrl()."\">\n";
	print "<p><input type=\"submit\" value=\"".MSG_REBUILD2."\"></p>\n";
	print "</form>\n";
	print "</body></html>";
	exit;
}

//===============================================
// StartUp

if(phpversion()<"4.2.0") error(ERR_MSG_PHPVER);
if(!MB_OVERLOAD_STRING) error(ERR_MSG_MBSTRING);
if(!MB_OVERLOAD_REGEX) error(ERR_MSG_MBREGEX);

// Module Setting
set_magic_quotes_runtime(false);
mb_http_output("pass");
mb_internal_encoding(SITE_CHARSET);
mb_language(SITE_LANG);
mb_regex_encoding(SITE_CHARSET);

// read config.ini
unset($g_config);
$g_config['return_if_modified']=1;
$g_config['cache_enable']=1;
$g_config['cache_pages_max']=64;
$g_config['resent_wb_log_max']=40;
if(file_exists(FNAME_CONFIG)){
	$data = _file(FNAME_CONFIG);
	foreach($data as $a) if($a){
		list($key,$value) = explode("=",str_replace("\n","",$a));
		if(isset($g_config[$key])) $g_config[$key]=$value;
	}
}
if($g_config['resent_wb_log_max']<=0){
	$g_config['resent_wb_log_max']=1;	// 最低１つは保存しないと最終更新日付が取得出来ない
}

// Is Cellphone Access?
$g_bCellphone=false;
$ua = $_SERVER["HTTP_USER_AGENT"];
if(ereg("DoCoMo",$ua)||ereg("J-PHONE",$ua)||ereg("UP\.Browser",$ua)||ereg("PDXGW",$ua)) $g_bCellphone=true;
if(ereg('cellphone',$_COOKIE[COOKIE_TESTFLAG])) $g_bCellphone=true;
if(($g_bCellphone)||($_GET['cache']=='off')||($_POST['cache']=='off')){
	$g_config['return_if_modified']=0;
	$g_config['cache_enable']=0;
}

// Administrator mode?
if(($_GET['mode']=='admin')||($_POST['mode']=='admin')) AdminMode();

// BBS（エントリが変更されるので ReadFileCache() より前に実行）
if($_POST['mode']=='bbs_write') bbs_write();
elseif($_POST['mode']=='bbs_delete') bbs_delete();

// Read File Cache
ReadFileCache();

// Writeback, Trackback
if($_POST['mode']=='wb_write') WriteBackSave();
if( ($_POST['url']) || ( (!TRACKBACK_POSTONLY)&&($_GET['url']) ) ) TrackBackSave();

// Is exist document?
$u = $_GET['u'];
SplitPath($u,$dir,$fname);
if($fname){
	if(!isset($g_filelist[str_replace(EXT_ACCESS,EXT_DOCUMENT,$u)])){
		$mes2 = '';
		foreach($g_filelist as $fn0 => $va0){
			if(ereg(ext_change($fname,EXT_DOCUMENT),$fn0)){
				$mes2 = ERR_MSG_404_REFIND."<br/>\n&gt; <a href=\"".MakeLinkUrl($fn0)."\">".
					$va0[FILELIST_TITLE]."</a>";
				break;
			}
		}
		error($u,ERR_404,$mes2);
	}
}else if($dir){
	if(!isset($g_dirlist[$dir])) error($dir,ERR_404);
}

// Referer check and save
RefererCheck();

// Etag, Last-Modified, If-Modified-Since
$g_LastModified = max(@filemtime(FNAME_RECENT_WB_LOG),@filemtime(FNAME_FILECACHE));
if(!$g_LastModified) $g_LastModified = time();
$etag = md5( $_SERVER["QUERY_STRING"] . $g_LastModified );
// getallheaders (or apache_request_headers) only supported when PHP runs as an Apache module.
if(($g_config['return_if_modified'])&&(function_exists("getallheaders"))){
	$request_head = getallheaders();
	$since = parse_rfctime( $request_head["If-Modified-Since"] );
	if($since >= $g_LastModified ){
		header( "HTTP/1.1 304 Not Modified" );
		header( "Etag: \"$etag\"" );
		exit();
	}
}

// Build HTML (Main!)
if(DEBUG_BUILDTIME) $time_start = getmicrotime();

$skin_main = '';
if($_GET['s']!=''){
	$skin_main = ext_change($_GET['s'],FNAME_SKIN_EXT);
	$g_config['cache_enable']=0;
}else{
	if($g_bCellphone){
		$skin_main = DIR_DATA.ext_change(FNAME_SKIN_BODY,'_i'.FNAME_SKIN_EXT);
		if(!file_exists($skin_main)) $skin_main = '';
	}
}
if($skin_main==''){
	$skin_main = DIR_DATA.$g_dirlist[$dir][DIRLIST_SKIN_BODY].FNAME_SKIN_BODY;
}

if($_GET['c']=='xml') $head=CONTENT_TYPE_XML; else $head=CONTENT_TYPE_HTML;
if($g_bCellphone) $head = ereg_replace(SITE_CHARSET,CELLPHONE_CHARSET,$head);
header($head);

if($g_config['return_if_modified']){
	header("Last-Modified: ".gmdate("D, d M Y H:i:s T",$g_LastModified));
	header("Etag: \"$etag\"");
}

$output = CreateHTML(NUM_ITEMS,$skin_main,$g_config['cache_enable']);
if(EVAL_ENABLE){
	ob_start();
	eval('?>'.$output);
	$output = ob_get_contents();
	ob_end_clean();
}

if(DEBUG_BUILDTIME){
	$t = getmicrotime() - $time_start;
	print number_format($t*1000, 3, '.', '');
}

if($g_bCellphone) $output = mb_convert_cellphone($output);
print $output;


?>

