<?php
/*---------------------------------------------------

	rNote Administrator Tool

	by Woody-Rinn 2004
	http://rinn.e-site.jp/

---------------------------------------------------*/

require("rnote_config.php");

//==================================================================================
// 初期設定
//==================================================================================

define(FNAME_RNOTE,'rnote.php');		// rnoteのファイル名。index.php とかに変えてる人は書き換えてください。
define(DIR_ADMINTOOL,'rnoteadmin/');	// 管理者ツールディレクトリ
define(FNAME_ADMINSKIN,DIR_ADMINTOOL.'rnoteadmin.skin');	// スキン

define(DISPSITE_NEWWINDOW,true);		// 「サイト表示」は新規ウィンドウで表示

// プラグイン
$plugin_list[] = 'wb_log';		// 最近のツッコミ等のログ
$plugin_list[] = 'config';		// rNoteの動作設定

//==================================================================================
// 定数定義・メッセージなど
//==================================================================================

define(RNOTE_URL,'http://rinn.e-site.jp/rnote/');

define(FNAME_FILECACHE,DIR_CACHE.'file.cache');
define(FNAME_DIRCACHE,DIR_CACHE.'dir.cache');
define(FNAME_RECENT_WB_LOG,DIR_CACHE.'recentwb.cache');
define(FNAME_CONFIG,DIR_CACHE.'config.ini');

define(COOKIE_AUTHENTICATION,'authentication');
define(COOKIE_LOGIN_ID_PASS,'rnote_admin_id_pass');
define(COOKIE_TESTFLAG,'rnote_testflag');

define(ERR_MSG_PHPVER,"PHPのバージョンが古いので動作出来ません。\nPHP 4.3 以上で動作します。");
define(ERR_MSG_MBSTRING,'マルチバイト文字列関数のサポートがありません。\nconfigureスクリプトで --enable-mbstring を指定してください。');
define(ERR_MSG_MBREGEX,'マルチバイト正規表現のサポートがありません。\nconfigureスクリプトで --enable-mbregex を指定してください。');

//==================================================================================
// 汎用サブルーチン
//==================================================================================

function error($mes){
	header(CONTENT_TYPE_HTML);
	print "<html><body>\n$mes\n</body></html>";
	exit;
}

if (!function_exists("file_get_contents")) {
	function file_get_contents($filename, $use_include_path = 0) {
		$data = ""; // just to be safe. Dunno, if this is really needed
		$file = @fopen($filename, "rb", $use_include_path);
		if ($file) {
			while (!feof($file)) $data .= fread($file, 1024);
			fclose($file);
		}
		return $data;
	}
}

function _file_get_contents($fname){
	if(!file_exists($fname)) error("$fname : File not found");
	$a = @file_get_contents($fname);
	if($a===false) error("$fname : File read error");
	if((ord($a{0})==0xef)&&(ord($a{1})==0xbb)&&(ord($a{2})==0xbf)) $a = substr($a,3);	// utf-8 bom delete
	$a = str_replace("\r","\n",str_replace("\r\n","\r",$a));
	return $a;
}
function _file($fname){
	if(!file_exists($fname)) error("$fname : File not found");
	$a = @file($fname);
	if($a===false) error("$fname : File read error");
	return $a;
}
function _fopen_wb($fname){
	$fp = @fopen($fname, "wb");
	if(! $fp) error("$fname : File write error");
	set_file_buffer($fp, 0);
	flock($fp, LOCK_EX);
	rewind($fp);
	return $fp;
}

function SplitPath($path,&$dir,&$fname){
	$dir = $fname = '';
	if(preg_match('/^[^\.]*[^\/]$/',$path)) $path .= '/';
	if(preg_match('/(^.*\/|^)(.*?)$/',$path,$tmp)){
		if($tmp[1]) $dir = $tmp[1];
		if($tmp[2]) $fname = $tmp[2];
	}
}
function ext_change($fname,$new_ext){
	return preg_replace('/\.[^\/\.]*$/','',$fname) . $new_ext;
}
function get_XMLTag($tag,&$str){
	if(preg_match("/<$tag.*?>[[:space:]]*(.*)[[:space:]]*<\/$tag>/s",$str,$buf)) {
		return $buf[1];
	}
	return '';
}

function MakeLinkUrl($fname=''){
	$fname = str_replace(EXT_DOCUMENT,EXT_ACCESS,$fname);
	SplitPath($_SERVER['PHP_SELF'],$base,$tmp);
	if(USE_MOD_REWRITE){
		$base .= $fname;
	}else{
		$base .= FNAME_RNOTE.'?u='.$fname;
	}
	return $base;
}

// W3C-DTF->Unix Time
function w3cdtf_to_time($datetime){
	list($year,$month,$day,$hour,$minute,$second) = explode(' ',preg_replace('/[^0-9]+/',' ',$datetime));
	if(!$year) $year=1970;
	if(!$month) $month=1;
	if(!$day) $day=1;
	if(($month>12)||($day>31)||($hour>24)||($minute>60)||($second>60)) return false;
	$offset_hour = $offset_minute = 0;
	if(preg_match('/(\+|-)(\d+):(\d+)$/', $datetime, $val)){
		$offset_hour   = $val[1].$val[2];
		$offset_minute = $val[1].$val[3];
	}
	return mktime($hour - $offset_hour, $minute - $offset_minute, $second, $month, $day, $year);
}

//==================================================================================
// 本体
//==================================================================================

//----------------------------------------------------
// Loginシーケンス
// ID&PASS未入力でログインフォーム出力、認証失敗でエラーメッセージ、成功時は '' が返ります。
function Login(){
	$ret = '';
	if($_COOKIE[COOKIE_AUTHENTICATION]!=ADMIN_ID.'-'.ADMIN_PASSWORD){
		if((!$_POST['PHP_AUTH_USER'])&&(!$_POST['PHP_AUTH_PW'])){
			$bSaveCookie = $ck_id = $ck_pass = '';
			if($_COOKIE[COOKIE_LOGIN_ID_PASS]){
				$bSaveCookie = 'checked="checked" ';
				list($ck_id,$ck_pass) = explode("\t", $_COOKIE[COOKIE_LOGIN_ID_PASS]);
			}
			$ret .= "<form method=\"post\" action=\"".$_SERVER['PHP_SELF']."\">\n";
			$ret .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"form\">\n";
			$ret .= "<tr><td>ID: </td><td><input type=\"text\" name=\"PHP_AUTH_USER\" size=\"60\" maxlength=\"100\" value=\"$ck_id\" /></td></tr>\n";
			$ret .= "<tr><td>PASS: </td><td><input type=\"password\" name=\"PHP_AUTH_PW\" size=\"60\" maxlength=\"100\" value=\"$ck_pass\" /></td></tr>\n";
			$ret .= "<tr><td colspan=\"2\"><input type=\"checkbox\" name=\"savecookie\" value=\"1\" $bSaveCookie/> IDとPASSをクッキーに記憶させる</td></tr>\n";
			$ret .= "<tr><td colspan=\"2\"><input type=\"submit\" value=\"Login\" /></td></tr>\n";
			$ret .= "</table></form>\n";
		}else{
			if(!$_POST['savecookie']) setcookie(COOKIE_LOGIN_ID_PASS, '');
			if(($_POST['PHP_AUTH_USER']!=ADMIN_ID)||($_POST['PHP_AUTH_PW']!=ADMIN_PASSWORD)){
				$ret .= "Authorization Required\n";
			}else{
				setcookie(COOKIE_AUTHENTICATION, ADMIN_ID.'-'.ADMIN_PASSWORD);
				if($_POST['savecookie']){
					setcookie(COOKIE_LOGIN_ID_PASS, implode("\t",array(ADMIN_ID,ADMIN_PASSWORD)), time()+2*7*24*3600);
				}
			}
		}
	}
	return $ret;
}

//----------------------------------------------------
// StartUp

if(phpversion()<"4.2.0") error(ERR_MSG_PHPVER);
if(!MB_OVERLOAD_STRING) error(ERR_MSG_MBSTRING);
if(!MB_OVERLOAD_REGEX) error(ERR_MSG_MBREGEX);

set_magic_quotes_runtime(false);
mb_http_output("pass");
mb_internal_encoding(SITE_CHARSET);
mb_language(SITE_LANG);
mb_regex_encoding(SITE_CHARSET);

$html_data = Login();

if($html_data==''){	// 認証通過

	//-----------------------------------------
	// プラグインをロード
	unset($plugin);
	foreach($plugin_list as $name){
		require_once(DIR_ADMINTOOL.$name.'.php');
		$plugin[$name]['obj'] = new $name;
		$info = $plugin[$name]['obj']->getinfo();
		$plugin[$name]['btn_name'] = $info['btn_name'];
		$plugin[$name]['title'] = $info['title'];
	}

	//-----------------------------------------
	// ツールバー描画
	$html_data .= "<div class=\"toolbar\">\n";
	$html_data .= "<table border=\"0\" cellspacing=\"2\" cellpadding=\"0\"><tr>\n";
	foreach($plugin as $name => $a){
		$html_data .= "<td><a href=\"".$_SERVER['PHP_SELF']."?disp=$name\">".$a['btn_name']."</a></td>\n";
	}
//	$html_data .= "<td><a href=\"".$_SERVER['PHP_SELF']."?disp=config\">動作設定</a></td>\n";
	$html_data .= "<td class=\"spacer\"></td>\n";
	$html_data .= "<td><a href=\"".FNAME_RNOTE."\"";
	if(DISPSITE_NEWWINDOW) $html_data .= " target=\"_blank\"";
	$html_data .= ">サイト表示</a></td>\n";
	$html_data .= "<td class=\"spacer\"></td>\n";

	// 再構築ボタン
	$html_data .= "<td><form method=\"post\" action=\"".FNAME_RNOTE."\"";
	if(DISPSITE_NEWWINDOW) $html_data .= " target=\"_blank\"";
	$html_data .= ">\n";
	$html_data .= "<input type=\"hidden\" name=\"mode\" value=\"admin\">\n";
	$html_data .= "<input type=\"hidden\" name=\"PHP_AUTH_USER\" value=\"".ADMIN_ID."\">\n";
	$html_data .= "<input type=\"hidden\" name=\"PHP_AUTH_PW\" value=\"".ADMIN_PASSWORD."\">\n";
	$html_data .= "<input type=\"submit\" value=\"再構築\" class=\"button\">\n";
	$html_data .= "</form></td>\n";

	$html_data .= "</table>\n";
	$html_data .= "</div>\n";

	//-----------------------------------------
	// コンテンツ表示
	$html_data .= "<div class=\"content\">\n";
	$plugin_name = $_GET['disp'];
	if(!isset($plugin[$plugin_name])){
		reset($plugin);
		list($plugin_name, $val) = each($plugin);
	}
	$html_data .= "<h2>".$plugin[$plugin_name]['title']."</h2>\n";
	$html_data .= $plugin[$plugin_name]['obj']->disp();
	$html_data .= "</div>\n";
}else{
	$html_data = "<div class=\"content\">\n$html_data</div>\n";
}

$skin = _file_get_contents(FNAME_ADMINSKIN);
$skin = str_replace('<%=$site_lang%>',SITE_LANG,$skin);
$skin = str_replace('<%=$site_charset%>',SITE_CHARSET,$skin);
$skin = str_replace('<%=$rnote_url%>',RNOTE_URL,$skin);
$skin = str_replace('<%=$content%>',$html_data,$skin);

header(CONTENT_TYPE_HTML);
print $skin;

?>
